proc go_hits_init {} {
    global closeImg
    global checkedImg
    global uncheckedImg
    
    #Creating menu buttons
    .menubar.tab.menu add command -label "GO hits" -command "catch {create_tab go}"
    
    # GO Hits
    set notebook .result.notebook2.nb
    set frame [$notebook insert end go -text "GO hits" -raisecmd "catch {update_info_go}"]
    frame $frame.0
    label $frame.0.label1 -font 12
    button $frame.0.exit -image $closeImg -highlightthickness 0 -takefocus 0 -command "close_tab go"
    frame $frame.1
    frame $frame.1.table
    scrollbar $frame.1.y -orient vertical -command "$frame.1.table.l yview"
    scrollbar $frame.x -orient horizontal -command "$frame.1.table.l xview"
    set nb2_tl_go_results $frame.1.table.l
    tablelist::tablelist $nb2_tl_go_results \
            -width 10 -height 1 -showseparators 1 -stripebackground lightblue\
            -columns {
                0 "" \
                0 "prot name" 0 "id" 0 "category" 0 "name" 0 "description" 0 "id_prot" 0 "seqBrowser_row"} \
            -labelcommand "$nb2_tl_go_results finishediting; tablelist::sortByColumn" \
            -exportselection 0 \
            -stretch all \
            -selectmode single \
            -editendcommand editEndCmd \
            -yscrollcommand "$frame.1.y set" \
            -xscrollcommand "$frame.x set" \
            -background white
    $nb2_tl_go_results columnconfigure 0 \
            -sortmode integer \
            -editable yes \
            -editwindow checkbutton \
            -formatcommand emptystr \
            -labelimage [expr {1 ? $checkedImg : $uncheckedImg}] \
            -labelcommand "table_selection"
    
    $nb2_tl_go_results columnconfigure 6 -hide yes
    $nb2_tl_go_results columnconfigure 7 -hide yes
    for {set i 1} {$i <= 5} {incr i} {
        $nb2_tl_go_results columnconfigure $i -sortmode dictionary
    }
    
    pack $frame.1.table.l -side left -fill both -expand true
    pack $frame.1.y -side left -fill both; pack $frame.1.table -side left -fill both -expand true
    pack $frame.0.label1 -side left -fill both -anchor w; pack $frame.0.exit -side right -fill both -anchor e
    pack $frame.0 -side top -fill both; pack $frame.1 -side top -fill both -expand true
    pack $frame.x -side top -fill both
    
    #GO hits rightmenu
    set tl .result.notebook2.nb.fgo.1.table.l
    bind [$tl bodypath] <Button-3> "
    set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
    catch \{set coord \"\[expr {%x + \[winfo x %W\]}\] \[expr {%y + \[winfo y %W\]}\]\"\}
    set id \[lindex \[$tl get \$y\] 2\]
    rightmenu_go_hits go go \$id \$coord
    "
}

proc go_hits_remove {} {
    #Remove menu buttons
    .menubar.tab.menu delete "GO hits"
    .result.notebook2.nb delete go
}

proc update_info_go {} {
    global env
    .result.notebook2.nb.fgo.0.label1 configure -text $env(contig.name)
    fillTable .result.notebook2.nb.fgo.1.table.l 0 0
}

proc update_info_go_table {name row} {
    global tabArr
    global env
    
    if {$tabArr(sb.exist) && $row ne ""} {
        set seqRow [expr $row + 1]
        foreach prot $env(contig.proteinL) {
            if {[lindex $prot 5] eq $name} {
                set fr [lindex $prot 0]
                set protSeq [lindex $prot 6]
            }
        }
        set pos [translateNuc $env(contig.sequence) $protSeq $fr]
        if {$fr eq 1 || $fr eq 2 || $fr eq 3 || $fr eq "+"} {
            set nstart [lindex $pos 0]
            set nend [lindex $pos 1]
        } else  {
            set nstart [expr [string length $nucSeq] - [lindex $pos 1]]
            set nend [expr [string length $nucSeq] - [lindex $pos 0]]
        }
        catch {.result.notebook1.nb.fsb.1.panel tag remove markedGreen 1.0 1000.end}
        catch {.result.notebook1.nb.fsb.1.panel tag remove markedOrange 1.0 1000.end}
        catch {.result.notebook1.nb.fsb.1.panel tag add markedGreen $seqRow.0 $seqRow.end}
        catch {.result.notebook1.nb.fsb.1.panel tag add markedGreen 2.$nstart 2.$nend}
    }
}

proc rightmenu_go_hits {mode feat id coord} {
    global env
    
    .rightmenu delete 0 end
    .rightmenu.hidemenuColumn delete 0 end
    .rightmenu.copymenu delete 0 end

    .rightmenu add command -label "Show all hits" -command "catch {search_right $feat $id}"
    .rightmenu add separator
    .rightmenu add cascade -label "Copy..." -menu .rightmenu.copymenu
    .rightmenu.copymenu add command -label "Cell" -command "catch {table_copy \"cell [lindex $coord 0] [lindex $coord 1]\" .result.notebook2.nb.fgo.1.table.l}"
    .rightmenu.copymenu add command -label "Column" -command "catch {table_copy \"column [lindex $coord 0]\" .result.notebook2.nb.fgo.1.table.l}"
    .rightmenu.copymenu add command -label "Row" -command "catch {table_copy \"row [lindex $coord 1]\" .result.notebook2.nb.fgo.1.table.l}"
    .rightmenu.copymenu add command -label "Table" -command "catch {table_copy all .result.notebook2.nb.fgo.1.table.l}"
    
    tk_popup .rightmenu [winfo pointerx .] [winfo pointery .]
}