proc go_statistics_init {} {
    global env
    global closeImg
    global go_stat_canTagL
    
    set env(go_statArr.results) 0
    set go_stat_canTagL ""
    
    #Creating menu buttons
    .menubar.tab.menu add command -label "GO statistics" -command "catch {create_tab go_stat}"
    
    # GO Statistics
    set notebook .result.notebook2.nb
    set frame [$notebook insert end go_stat -text "GO statistics" -raisecmd "go_tree_raise .result.notebook2.nb.fgo_stat.1.tree.t"]
    frame $frame.0
    label $frame.0.label1 -font 12
    button $frame.0.compare -text Compare -command "go_tree_compare"
    frame $frame.0.view
    radiobutton $frame.0.view.diagram -text "Diagram" -variable goview_rb -value "Diagram" -command {pack forget .result.notebook2.nb.fgo_stat.1.fr.table; pack .result.notebook2.nb.fgo_stat.1.fr.can -side bottom -fill both -expand true; .result.notebook2.nb.fgo_stat.1.fr.x configure -command ".result.notebook2.nb.fgo_stat.1.fr.can xview"}
    radiobutton $frame.0.view.text -text "List      " -variable goview_rb -value "List" -command {pack forget .result.notebook2.nb.fgo_stat.1.fr.can; pack .result.notebook2.nb.fgo_stat.1.fr.table -side bottom -fill both -expand true; .result.notebook2.nb.fgo_stat.1.fr.x configure -command ".result.notebook2.nb.fgo_stat.1.fr.table.l xview"}
    $frame.0.view.diagram select
    button $frame.0.clear -text Clear -command "catch {go_tree_clear}"
    button $frame.0.exit -image $closeImg -highlightthickness 0 -takefocus 0 -command "::close_tab go_stat"
    frame $frame.1
    frame $frame.1.tree
    set tree [Tree $frame.1.tree.t -height 1 -background white -selectbackground LightSkyBlue -opencmd "go_tree_open .result.notebook2.nb.fgo_stat.1.tree.t" -closecmd "go_tree_close .result.notebook2.nb.fgo_stat.1.tree.t" -yscrollcommand "$frame.1.y set" -xscrollcommand "$frame.1.tree.x set"]
    scrollbar $frame.1.tree.x -orient horizontal -command "$frame.1.tree.t xview"
    scrollbar $frame.1.y -orient vertical -command "$frame.1.tree.t yview"
    frame $frame.1.fr
    canvas $frame.1.fr.can -background white -width 700 -height 1 -xscrollcommand "$frame.1.fr.x set"
    scrollbar $frame.1.fr.x -orient horizontal -command "$frame.1.fr.can xview"
    frame $frame.1.fr.table
    set go_stat_tl $frame.1.fr.table.l
    tablelist::tablelist $go_stat_tl \
            -width 24 -height 1 -showseparators 1 -stripebackground lightblue\
            -columns {0 "GO term" 0 "GO name" 0 "total hits"} \
            -labelcommand "$go_stat_tl finishediting; tablelist::sortByColumn" \
            -exportselection 0 \
            -selectmode single \
            -stretch 0 \
            -editendcommand editEndCmd \
            -yscrollcommand "$frame.1.fr.table.y set" \
            -xscrollcommand "$frame.1.fr.x set" \
            -background white
    scrollbar $frame.1.fr.table.y -orient vertical -command "$frame.1.fr.table.l yview"
    
    pack $frame.0.view.diagram $frame.0.view.text -fill both -side left
    pack $frame.0.compare $frame.0.label1 -side left -fill both -anchor w
    pack $frame.0.exit $frame.0.clear $frame.0.view -side right -anchor e
    pack $frame.1.fr.table.l -fill both -side left -expand true; pack $frame.1.fr.table.y -fill both -side left
    pack $frame.1.tree.t -fill both -side top -expand true; pack $frame.1.tree.x -fill both -side bottom
    pack $frame.1.tree -fill both -side left -expand true; pack $frame.1.y -fill both -side left
    pack $frame.1.fr.x -fill both -side bottom; pack $frame.1.fr.can -fill both -side top -expand true
    pack $frame.1.fr -fill both -side left -expand true
    pack $frame.0 -side top -fill both; pack $frame.1 -side top -fill both -expand true
    
    $tree bindText <Button-1> go_tree_select 
    $tree bindImage <Button-1> go_tree_select
    $tree bindText <Button-3> go_tree_show
    
    #GO statistics rightmenu
    set tl .result.notebook2.nb.fgo_stat.1.fr.table.l
    bind [$tl bodypath] <Button-3> "
    set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
    catch \{set coord \"\[expr {%x + \[winfo x %W\]}\] \[expr {%y + \[winfo y %W\]}\]\"\}
    set id \[lindex \[$tl get \$y\] 0\]
    rightmenu_go_stat go_stat list \$id \$coord
    "
}

proc go_statistics_remove {} {
    #Remove menu buttons
    .menubar.tab.menu delete "GO statistics"
    .result.notebook2.nb delete go_stat
}

proc go_tree_compare {} {
    global env
    
    set page [.result.notebook1.nb raise]
    if {[lindex [split $page _] 0] eq "prj"} {
        .result.notebook2.nb.fgo_stat.0.label1 configure -text "   Compare to '[.result.notebook1.nb itemcget $page -text]'"
        set tl1 ".result.notebook1.nb.f$page.1.table.l"
        $tl1 finishediting
        
        set stop 0
        set i 0
        set id_seqL ""
        
        while {$stop ne 1} {
            if {[lindex [$tl1 get $i] 0] eq 1 && [string tolower [lindex [$tl1 get $i] 24]] eq [string tolower $env(dbName)]} {
                lappend id_seqL [lindex [$tl1 get $i] 23]
            } elseif {[lindex [$tl1 get $i] 0] eq ""} {
                set stop 1
            }
            incr i
        }
        unset tl1
        unset stop
        if {$id_seqL ne ""} {
            set ::threadGO_Compare [thread::create {
                proc go_compare {processID mainThreadID phpThreadID id_seqL} {
                    global env
                    # M: total number of transcripts in database, with GO terms
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT COUNT(id_seq) AS hits FROM (SELECT DISTINCT id_seq FROM $env(dbName).go_hits) AS A"}}]]
                    foreach sRes $sql_res {
                        set env(go_statArr.M) [lindex $sRes 0]
                    }
                    unset sql_res
                    # N: number of transcripts from process tab, with GO terms
                    set env(go_statArr.N) [llength $id_seqL]
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id FROM refdb.gotree"}}]]
                    foreach sRes $sql_res {
                        set env(go_statArr.[lindex $sRes 0]) 0
                    }
                    unset sql_res
                    set id_seq ""
                    
                    foreach id_seq $id_seqL {
                        set ancestorL ""
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT member_of FROM refdb.gotree WHERE id IN (SELECT id FROM $env(dbName).go_hits WHERE id_seq = '$id_seq');"}}]]
                        foreach sRes $sql_res {
                            append ancestorL " [lindex $sRes 0]"
                        }
                        unset sql_res
                        set ancestorL [lsort -unique $ancestorL]
                        if {$ancestorL ne ""} {
                            set env(go_statArr.results) 1
                        }
                        foreach ancestor $ancestorL {
                            incr env(go_statArr.$ancestor)
                        }
                    }
                    if {$env(go_statArr.results) eq 0} {
                        eval [subst {thread::send -async $mainThreadID {errorPopUp "Error" "No GO hits for selected sequences."}}]
                    }
                    returnResult $processID finished $env(dbName) $mainThreadID
                }
                proc returnResult {processID status dbName mainThreadID} {
                    eval [subst {thread::send -async $mainThreadID {::process_update $processID $status - $dbName 1}}]
                }
                thread::wait
            }]
            
            set processID [llength $env(processL)]
            process_update $processID running "Calculate GO statistic for '[.result.notebook1.nb itemcget $page -text]'" $env(dbName) 0
            eval [subst {thread::send -async $::threadGO_Compare {::go_compare $processID $env(mainThreadID) $env(phpThreadID) {$id_seqL}}}]
        } else {
            errorPopUp "Error" "No selected sequences belonging to this database."
        }
    } else {
        errorPopUp "Error" "Please raise a project tab."
    }
}

proc go_tree_clear {} {
    global env
    global go_stat_canTagL
    
    .result.notebook2.nb.fgo_stat.1.fr.can delete a
    foreach tag $go_stat_canTagL {
        .result.notebook2.nb.fgo_stat.1.fr.can delete $tag
    }
    set go_stat_canTagL ""
    .result.notebook2.nb.fgo_stat.0.label1 configure -text ""
    set env(go_statArr.results) 0
    set env(go_statArr.N) 0
    set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id FROM refdb.gotree"}}]]
    foreach sRes $sql_res {
        set env(go_statArr.[lindex $sRes 0]) 0
    }
    unset sql_res
}

proc go_tree_create {t} {
    global env
    
    set parent_of ""
    catch {
        $t insert end root categories -data "GO:0008150 GO:0005575 GO:0003674" -text categories -drawcross allways
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT parent_of FROM refdb.gotree WHERE id = 'GO:0008150'"}}]]
        foreach sRes $sql_res {
            set parent_of [lindex $sRes 0]
        }
        unset sql_res
        $t insert end categories categories.GO:0008150 -data $parent_of -text "1: biological_process" -drawcross allways
        #$t insert end root GO:0008150 -data $parent_of -text biological_process -drawcross allways
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT parent_of FROM refdb.gotree WHERE id = 'GO:0005575'"}}]]
        foreach sRes $sql_res {
            set parent_of [lindex $sRes 0]
        }
        unset sql_res
        $t insert end categories categories.GO:0005575 -data $parent_of -text "2: cellular_component" -drawcross allways
        #$t insert end root GO:0005575 -data $parent_of -text cellular_component -drawcross allways
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT parent_of FROM refdb.gotree WHERE id = 'GO:0003674'"}}]]
        foreach sRes $sql_res {
            set parent_of [lindex $sRes 0]
        }
        unset sql_res
        $t insert end categories categories.GO:0003674 -data $parent_of -text "3: molecular_function" -drawcross allways
        #$t insert end root GO:0003674 -data $parent_of -text molecular_function -drawcross allways
    }
    unset parent_of
}

proc go_tree_raise {t} {
    global env
    
    if {$env(dbName) ne " "} {
        $t opentree categories 0
        go_tree_select categories
    }   
}

proc go_tree_open {t node} {
    global env
    
    set cL ""
    # Icon austauschen
    $t itemconfigure $node
    # alte Kinder-Knoten Löschen
    $t delete [$t nodes $node]
    
    # Verzeichnis aus Knoten
    set childs [$t itemcget $node -data]
    # Knoten für alle Kinder anlegen
    foreach child $childs {
        set parent_of ""
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT parent_of FROM refdb.gotree WHERE id = '$child'"}}]]
        foreach sRes $sql_res {
            set parent_of [lindex $sRes 0]
        }
        unset sql_res
        set color black
        set name ""
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT refdb.go.name AS name, $env(dbName).go_stat.hits AS hits FROM refdb.go INNER JOIN $env(dbName).go_stat ON $env(dbName).go_stat.id = refdb.go.id WHERE refdb.go.id = '$child'"}}]]
        foreach sRes $sql_res {
            set name [lindex $sRes 0]
            if {[lindex $sRes 1] ne 0} {
                set color green
            }
        }
        unset sql_res
        if {[llength $parent_of] > 0} {
            set dc allways
        } else {
            set dc never
        }
        if {$name ne ""} {
            lappend cL "{$name} $child $dc {$parent_of} $color"
        }
    }
    if {$cL ne ""} {
        set cL [lsort $cL]
        set i 1
        foreach c $cL {
            $t insert end $node $node.[lindex $c 1] -data [lindex $c 3] -text "$i: [lindex $c 0]" -drawcross [lindex $c 2] -fill [lindex $c 4]
            incr i
        }
        unset parent_of; unset name
    }
}

proc go_tree_close {t node} {
    $t itemconfigure $node
}

proc go_tree_select {node} {
    global env
    global go_stat_canTagL
    
    .result.notebook2.nb.fgo_stat.1.tree.t selection set $node    
    .result.notebook2.nb.fgo_stat.1.fr.can delete a
    foreach tag $go_stat_canTagL {
        .result.notebook2.nb.fgo_stat.1.fr.can delete $tag
    }
    set go_stat_canTagL ""
    
    if {$env(dbName) ne " "} {
        if {$node eq "categories"} {
            set sql_res "{{GO:0008150 GO:0005575 GO:0003674}}"
        } else {
            set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT parent_of FROM refdb.gotree WHERE id = '[lindex [split $node .] end]'"}}]]
        }
        
        if {[lindex [lindex $sql_res end] end] ne "Fehler"} {
            foreach sRes $sql_res {
                set columns [lindex $sRes 0]
            }
            unset sql_res
            set resL ""
            .result.notebook2.nb.fgo_stat.1.fr.table.l delete 0 end
            if {$env(go_statArr.results)} {
                .result.notebook2.nb.fgo_stat.1.fr.table.l configure -columns {0 "GO term" 0 "GO name" 0 "total_hits" 0 "project_hits" 0 "negative_dependency" 0 "positive_dependency" 0 "2-tail_dependency"}
            } else {
                .result.notebook2.nb.fgo_stat.1.fr.table.l configure -columns {0 "GO term" 0 "GO name" 0 "total_hits"}
            }
            if {[llength $columns] ne 0} {
                set out ""
                foreach column $columns {append tmpString ", '$column'"}
                set tmpString [string range $tmpString 2 end]
                set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id, hits FROM $env(dbName).go_stat WHERE id IN ($tmpString)"}}]]
                foreach sRes $sql_res {
                    if {$env(go_statArr.results)} {
                        lappend resL "[lindex $sRes 0] [lindex $sRes 1] $env(go_statArr.[lindex $sRes 0])"
                    } else {
                        lappend resL "[lindex $sRes 0] [lindex $sRes 1] 0"
                    }
                }
                
                unset sql_res
                foreach c $columns {
                    set hit 1
                    foreach res $resL {
                        if {$c eq [lindex $res 0]} {
                            set hit 0
                        }
                    }
                    if {$hit} {
                        lappend resL "$c 0 0"
                    }
                }
                unset columns
                foreach res $resL {
                    set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name FROM refdb.go WHERE id = '[lindex $res 0]'"}}]]
                    foreach sRes $sql_res {
                        set name [lindex $sRes 0]
                    }
                    unset sql_res
                    lappend out "{$name} [lindex $res 1] [lindex $res 2] [lindex $res 0]"
                }
                set out [lsort -unique $out]
                unset resL
                
                if {$out ne ""} {
                    set height [expr [winfo height .result.notebook2.nb.fgo_stat.1.fr.can] - 20]
                    set bars ""
                    set count 0
                    set max 0
                    set i 1
                    foreach o $out {
                        set pValue "N/A N/A N/A"
                        if {[lindex $o 1] ne 0} {
                            if {[lindex $o 1] > $max} {
                                set max [lindex $o 1]
                            }
                            if {$env(go_statArr.results)} {
                                set pValue [pValue $env(go_statArr.N) [lindex $o 2] $env(go_statArr.M) [lindex $o 1]]
                            }
                            incr count
                            lappend bars "$i [lindex $o 1] [lindex $o 2] [lindex $pValue 0] [lindex $pValue 1] [lindex $pValue 2]"
                        }
                        incr i
                        if {$env(go_statArr.results)} {
                            .result.notebook2.nb.fgo_stat.1.fr.table.l insert end "[lindex $o 3] {[lindex $o 0]} [lindex $o 1] [lindex $o 2] [lindex $pValue 0] [lindex $pValue 1] [lindex $pValue 2]"
                        } else {
                            .result.notebook2.nb.fgo_stat.1.fr.table.l insert end "[lindex $o 3] {[lindex $o 0]} [lindex $o 1]"
                        }
                    }
                    
                    if {$env(go_statArr.results)} {
                        set w 60
                    } else  {
                        set w 30
                    }
                    set width [expr $w * 2 * $count]
                    if {$width ne 0} {
                        .result.notebook2.nb.fgo_stat.1.fr.can create line 20 20 20 $height -tag a
                        .result.notebook2.nb.fgo_stat.1.fr.can create line 20 $height [expr $width + 20] $height -tag a
                    }
                    unset count
                    set j 0
                    foreach b $bars {
                        set bh0 [lindex [split [expr 1 + ($height.0 - 20) / $max.0 * [lindex $b 1].0] .] 0]
                        set bh1 [lindex [split [expr 1 + ($height.0 - 20) / $max.0 * [lindex $b 2].0] .] 0]
                        .result.notebook2.nb.fgo_stat.1.fr.can create rect [expr 25 + (2 * $j) * $w] [expr $height - $bh0] [expr 20 + (2 * $j + 1) * $w] $height -fill green -tag t0$j
                        set comm "rightmenu_go_stat go_stat diagram {[lindex [lindex $out [expr [lindex $b 0] - 1]] end]} 0"
                        .result.notebook2.nb.fgo_stat.1.fr.can bind t0$j <ButtonRelease-3> $comm
                        .result.notebook2.nb.fgo_stat.1.fr.can bind t0$j <Any-Enter> "after 800 [list toolTip_show %W \"[lindex [lindex $out [expr [lindex $b 0] - 1]] 0]\"]"
                        .result.notebook2.nb.fgo_stat.1.fr.can bind t0$j <Any-Leave> "destroy %W.balloon"
                        lappend go_stat_canTagL t0$j
                        .result.notebook2.nb.fgo_stat.1.fr.can create text [expr 25 + 2 * $j * $w] [expr $height + 10] -text [lindex $b 0] -anchor w -tag a
                        .result.notebook2.nb.fgo_stat.1.fr.can create text [expr 25 + 2 * $j * $w] [expr $height - 10 - $bh0] -text [lindex $b 1] -anchor w -tag a
                        if {$env(go_statArr.results)} {
                            if {[lindex $b 2] ne 0} {
                                .result.notebook2.nb.fgo_stat.1.fr.can create rect [expr 25 + (0.5 + 2 * $j) * $w] [expr $height - $bh1] [expr 20 + (2 * $j + 1.5) * $w] $height -fill red -tag t1$j
                                .result.notebook2.nb.fgo_stat.1.fr.can create text [expr 25 + (1 + 2 * $j) * $w] [expr $height - 10 - $bh1] -text [lindex $b 2] -anchor w -tag a
                                .result.notebook2.nb.fgo_stat.1.fr.can bind t1$j <Any-Enter> "after 600 [list toolTip_show %W \"[lindex [lindex $out [expr [lindex $b 0] - 1]] 0]\\nLeft:   [lindex $b 3]\\nRight:  [lindex $b 4]\\n2-Tail: [lindex $b 5]\"]"
                                .result.notebook2.nb.fgo_stat.1.fr.can bind t1$j <Any-Leave> "destroy %W.balloon"
                                lappend go_stat_canTagL t1$j
                            }
                        }
                        incr j
                    }
                    unset out
                    set scrollregion "0 0 $width 0"
                    .result.notebook2.nb.fgo_stat.1.fr.can configure -scrollregion $scrollregion
                }
            }
        } else {
            ::errorPopUp "Error" "Could not access GO-tree."
        }
    }
}

proc toolTip {t help} {
    bind $t <Any-Enter> "after 1000 [list toolTip_show %W \"$help\"]"
    bind $t <Any-Leave> "destroy %W.balloon"
}

proc go_tree_show {node} {
    rightmenu_go_stat go_stat diagram [lindex [split $node .] end] 0
}

proc pValue {n1 n11 n n_1} {
    set n1 $n1.0
    set n11 $n11.0
    set n $n.0
    set n_1 $n_1.0
    set n12 [expr $n1 - $n11]
    set n21 [expr $n_1 - $n11]
    set n22 [expr $n - $n1 - $n21]
    set tmp [exact $n11 $n1 $n_1 $n]
    #set prob [human_readable [lindex $tmp 0]]
    set left [human_readable [lindex $tmp 1]]
    set right [human_readable [lindex $tmp 2]]
    set twotail [expr [lindex $tmp 3] + [lindex $tmp 4]]
    if {$twotail > 1} {set twotail 1}
    set twotail [human_readable $twotail]
    
    
    return "$left $right $twotail"
}

proc human_readable {p} {
    set p [regsub -all {[\.e]} $p " "]
    if {[llength $p] eq 2} {
        if {[lindex $p 0] eq 0} {
            set count 1
            set n 0
            for {set j 0} {$j < [string length [lindex $p 1]]} {incr j} {
                if {[string index [lindex $p 1] $j] eq 0} {
                    incr count
                } else {
                    set n [string index [lindex $p 1] $j]
                    break
                }
            }
            if {$count > 3} {
                incr j
                set p "$n.[string range [lindex $p 1] $j [expr $j + 3]]e-$count"
            } else {
                set p "[lindex $p 0].[string range [lindex $p 1] 0 4]"
            }
        } else {
            set p "[lindex $p 0].[string range [lindex $p 1] 0 2]"
        }
    } elseif {[llength $p] eq 3} {
        set p "[lindex $p 0].[string range [lindex $p 1] 0 2]e[lindex $p 2]"
    }
    return $p
}

proc exact {n11 n1 n_1 n} {
    set max $n1
    if {$n_1 < $max} {set max $n_1}
    set min [expr $n1 + $n_1 - $n]
    if {$min < 0} {set min 0}
    if {$min == $max} {
        set sless 1
        set sright 1
        set sleft 1
        set slarg 1
        return "1 1 1 1 1"
    }
    set prob [hyper $n11 $n1 $n_1 $n]
    set sleft 0
    set p [hyper $min 0 0 0]
    for {set i [expr int($min) + 1]} {$p < [expr 0.99999999 * $prob]} {incr i} {
        set sleft [expr $sleft + $p]
        set p [hyper $i 0 0 0]
    }
    set i [expr $i - 1]
    if {$p < [expr 1.00000001 * $prob]} {
        set sleft [expr $sleft + $p]
    } else {
        set i [expr $i - 1]
    }
    set sright 0
    set p [hyper $max 0 0 0]
    for {set j [expr int($max) - 1]} {$p < [expr 0.99999999 * $prob]} {set j [expr $j - 1]} {
        set sright [expr $sright + $p]
        set p [hyper $j 0 0 0]
    }
    incr j
    if {$p < [expr 1.00000001 * $prob]} {
        set sright [expr $sright + $p]
    } else {
        incr j
    }
    if {[expr abs(($i - $n11))] < [expr abs(($j - $n11))]} {
        set sless $sleft
        set slarg [expr 1 - $sleft + $prob]
    } else {
        set sless [expr 1 - $sright + $prob]
        set slarg $sright
    }
    return "$prob $sless $slarg $sleft $sright"
}

proc lngamm {z} {
    set x 0
    set x [expr $x + 0.1659470187408462e-06 / ($z + 7) + 0.9934937113930748e-05 / ($z + 6) - 0.1385710331296526 / ($z + 5) + 12.50734324009056 / ($z + 4) - 176.6150291498386 / ($z + 3) + 771.3234287757674 / ($z + 2) - 1259.139216722289 / ($z + 1) + 676.5203681218835 / $z + 0.9999999999995183]
    return [expr log($x) - 5.58106146679532777 - $z + ($z - 0.5) * log(($z + 6.5))]
}

proc lnfact {n} {
    if {$n <= 1} {return 0}
    return [lngamm [expr $n + 1]]
}

proc lnbico {n k} {
    return [expr [lnfact $n] - [lnfact $k] - [lnfact [expr $n - $k]]]
}

proc hyper_323 {n11 n1_ n_1 n} {
    return [expr exp(([lnbico $n1_ $n11] + [lnbico [expr $n - $n1_] [expr $n_1 - $n11]] - [lnbico $n $n_1]))]
}

proc hyper {n11i n1_i n_1i ni} {
    global sn11
    global sn1_
    global sn_1
    global sn
    global sprob
    if {$n1_i == 0 && $n_1i == 0 && $ni == 0} {
        if {[expr fmod($n11i,10)] != 0} {
            if {$n11i == [expr $sn11 + 1]} {
                set sprob  [expr $sprob * (($sn1_ - $sn11) / $n11i) * (($sn_1 - $sn11) / ($n11i + $sn - $sn1_ - $sn_1))]
                set sn11 $n11i
                return $sprob
            }
            if {$n11i == [expr $sn11 - 1]} {
                set sprob  [expr $sprob * ($sn11 / ($sn1_ - $n11i)) * (($sn11 + $sn - $sn1_ - $sn_1) / ($sn_1 - $n11i))]
                set sn11 $n11i
                return $sprob
            }
        }
        set sn11 $n11i
    } else {
        set sn11 $n11i
        set sn1_ $n1_i
        set sn_1 $n_1i
        set sn $ni
    }
    set sprob [hyper_323 $sn11 $sn1_ $sn_1 $sn]
    return $sprob
}

proc rightmenu_go_stat {mode feat id coord} {
    global env
    
    .rightmenu delete 0 end
    .rightmenu.hidemenuColumn delete 0 end
    .rightmenu.copymenu delete 0 end
    
    if {$feat eq "diagram"} {
        .rightmenu add command -label "Show all hits" -command "catch {search_right $mode $id}"
    } elseif {$feat eq "list"} {
        .rightmenu add command -label "Show all hits" -command "catch {search_right $mode $id}"
        .rightmenu add cascade -label "Copy..." -menu .rightmenu.copymenu
        .rightmenu.copymenu add command -label "Cell" -command "catch {table_copy \"cell [lindex $coord 0] [lindex $coord 1]\" .result.notebook2.nb.fgo_stat.1.fr.table.l}"
        .rightmenu.copymenu add command -label "Column" -command "catch {table_copy \"column [lindex $coord 0]\" .result.notebook2.nb.fgo_stat.1.fr.table.l}"
        .rightmenu.copymenu add command -label "Row" -command "catch {table_copy \"row [lindex $coord 1]\" .result.notebook2.nb.fgo_stat.1.fr.table.l}"
        .rightmenu.copymenu add command -label "Table" -command "catch {table_copy all .result.notebook2.nb.fgo_stat.1.fr.table.l}"
    }
    
    tk_popup .rightmenu [winfo pointerx .] [winfo pointery .]
}