proc interpro_init {} {
    global env
    global closeImg
    global checkedImg
    global uncheckedImg
    
    #Creating menu buttons
    .menubar.config.menu add command -label "InterProScan results" -command "interpro_config"
    .menubar.tab.menu add command -label "InterProScan results" -command "catch {create_tab ips}"
    .menubar.tool.menu add command -label "InterProScan" -command "database_interpro_window" -state disabled
    
    #InterProScan_path
    set env(database_interpro.location_path) " "
    #set env(database_interpro.location_url) "http://www.ebi.ac.uk/Tools/services/web_iprscan/toolresult.ebi"
    set env(database_interpro.location_url) "http://www.ebi.ac.uk/Tools/es/cgi-bin/iprscan/iprscan.cgi"
    
    if {[catch {set ft [open [pwd]/conf/interpro_tace.conf r]} ]} {
        #Interproscan_results
        set env(interproscan_results.protname) +
        set env(interproscan_results.length) +
        set env(interproscan_results.feat) +
        set env(interproscan_results.description) +
        set env(interproscan_results.start) +
        set env(interproscan_results.end) +
        set env(interproscan_results.evalue) +
        set env(interproscan_results.blastprodom) +
        set env(interproscan_results.coil) +
        set env(interproscan_results.gene3d) +
        set env(interproscan_results.go) +
        set env(interproscan_results.interpro) +
        set env(interproscan_results.panther) +
        set env(interproscan_results.patternscan) +
        set env(interproscan_results.pfam) +
        set env(interproscan_results.pir) +
        set env(interproscan_results.profilescan) +
        set env(interproscan_results.smart) +
        set env(interproscan_results.superfamily) +
        set env(interproscan_results.tigr) +
    } else {
        #Interproscan_results
        gets $ft line
        gets $ft line
        set env(interproscan_results.protname) [lindex $line 0]
        set env(interproscan_results.length) [lindex $line 1]
        set env(interproscan_results.feat) [lindex $line 2]
        set env(interproscan_results.description) [lindex $line 3]
        set env(interproscan_results.start) [lindex $line 4]
        set env(interproscan_results.end) [lindex $line 5]
        set env(interproscan_results.evalue) [lindex $line 6]
        set env(interproscan_results.blastprodom) [lindex $line 7]
        set env(interproscan_results.coil) [lindex $line 8]
        set env(interproscan_results.gene3d) [lindex $line 9]
        set env(interproscan_results.go) [lindex $line 10]
        set env(interproscan_results.interpro) [lindex $line 11]
        set env(interproscan_results.panther) [lindex $line 12]
        set env(interproscan_results.patternscan) [lindex $line 13]
        set env(interproscan_results.pfam) [lindex $line 14]
        set env(interproscan_results.pir) [lindex $line 15]
        set env(interproscan_results.profilescan) [lindex $line 16]
        set env(interproscan_results.smart) [lindex $line 17]
        set env(interproscan_results.superfamily) [lindex $line 18]
        set env(interproscan_results.tigr) [lindex $line 19]
        #InterProScan_path
        gets $ft line
        gets $ft line
        set env(database_interpro.location_path) $line
        gets $ft line
        set env(database_interpro.location_url) $line
    }
    
    #InterPro Hits
    set notebook .result.notebook2.nb
    set frame [$notebook insert end ips -text "InterProScan results" -raisecmd "catch {update_info_ips}"]
    frame $frame.0
    label $frame.0.label1 -font 12
    button $frame.0.exit -image $closeImg -highlightthickness 0 -takefocus 0 -command "close_tab ips"
    frame $frame.1
    frame $frame.1.table
    scrollbar $frame.1.y -orient vertical -command "$frame.1.table.l yview"
    scrollbar $frame.x -orient horizontal -command "$frame.1.table.l xview"
    set nb2_tl_ips_results $frame.1.table.l
    tablelist::tablelist $nb2_tl_ips_results \
            -width 10 -height 1 -showseparators 1 -stripebackground lightblue\
            -columns {
                0 "" \
                0 "prot name" 0 "feature" 0 "id" 0 "description" 0 "start" 0 "end" 0 "length" 0 "eValue" 0 "id_prot" 0 "num" 0 "seqBrowser_row"} \
            -labelcommand "$nb2_tl_ips_results finishediting; tablelist::sortByColumn" \
            -exportselection 0 \
            -stretch {1 2 3 4 5 6 7 8} \
            -selectmode single \
            -editendcommand editEndCmd \
            -yscrollcommand "$frame.1.y set" \
            -xscrollcommand "$frame.x set" \
            -background white
    $nb2_tl_ips_results columnconfigure 0 \
            -sortmode integer \
            -editable yes \
            -editwindow checkbutton \
            -formatcommand emptystr \
            -labelimage [expr {1 ? $checkedImg : $uncheckedImg}] \
            -labelcommand "table_selection"
    
    $nb2_tl_ips_results columnconfigure 9 -hide yes
    $nb2_tl_ips_results columnconfigure 10 -hide yes
    $nb2_tl_ips_results columnconfigure 11 -hide yes
    for {set i 1} {$i <= 4} {incr i} {
        $nb2_tl_ips_results columnconfigure $i -sortmode dictionary
    }
    
    if {$env(interproscan_results.protname) eq "-"} {
        $nb2_tl_ips_results columnconfigure 1 -hide yes
    }
    if {$env(interproscan_results.length) eq "-"} {
        $nb2_tl_ips_results columnconfigure 2 -hide yes
    }
    if {$env(interproscan_results.feat) eq "-"} {
        $nb2_tl_ips_results columnconfigure 3 -hide yes
    }
    if {$env(interproscan_results.description) eq "-"} {
        $nb2_tl_ips_results columnconfigure 4 -hide yes
    }
    if {$env(interproscan_results.start) eq "-"} {
        $nb2_tl_ips_results columnconfigure 5 -hide yes
    }
    if {$env(interproscan_results.end) eq "-"} {
        $nb2_tl_ips_results columnconfigure 6 -hide yes
    }
    if {$env(interproscan_results.evalue) eq "-"} {
        $nb2_tl_ips_results columnconfigure 7 -hide yes
    }
    
    pack $frame.1.table.l -side left -fill both -expand true
    pack $frame.1.y -side left -fill both; pack $frame.1.table -side left -fill both -expand true
    pack $frame.0.label1 -side left -fill both -anchor w; pack $frame.0.exit -side right -fill both -anchor e
    pack $frame.0 -side top -fill both; pack $frame.1 -side top -fill both -expand true
    pack $frame.x -side top -fill both
    
    #InterPro_results rightmenu
    set tl .result.notebook2.nb.fips.1.table.l
    bind [$tl bodypath] <Button-3> "
    set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
    catch \{set coord \"\[expr {%x + \[winfo x %W\]}\] \[expr {%y + \[winfo y %W\]}\]\"\}
    set feat \[lindex \[$tl get \$y\] 2\]
    set id \[lindex \[$tl get \$y\] 3\]
    rightmenu_interpro ips \$feat \$id \$coord
    "
}

proc interpro_remove {} {
    #Remove menu buttons
    .menubar.config.menu delete "InterProScan results"
    .menubar.tab.menu delete "InterProScan results"
    .menubar.tool.menu delete "InterProScan"
    .result.notebook2.nb delete ips
}

proc database_interpro_window {} {
    global env
    
    set t .interpro
    toplevel $t
    wm title $t "Run InterProScan"
    wm resizable $t 0 0
    wm attributes $t -topmost 1
    
    frame $t.ptitle
    label $t.ptitle.label -text "Run InterProScan for:"
    
    set env(database_interpro.blastprodom) +
    set env(database_interpro.coil) -
    set env(database_interpro.gene3d) +
    set env(database_interpro.panther) +
    set env(database_interpro.patternscan) +
    set env(database_interpro.pfam) +
    set env(database_interpro.pir) +
    set env(database_interpro.profilescan) +
    set env(database_interpro.smart) +
    set env(database_interpro.superfamily) +
    set env(database_interpro.tigr) +
    
    frame $t.showFeat
    checkbutton $t.showFeat.blastprodom -text "blastprodom" -variable env(database_interpro.blastprodom) -offvalue "-" -onvalue "+"
    checkbutton $t.showFeat.coil -text "coil" -variable env(database_interpro.coil) -offvalue "-" -onvalue "+"
    checkbutton $t.showFeat.gene3d -text "gene3d" -variable env(database_interpro.gene3d) -offvalue "-" -onvalue "+"
    checkbutton $t.showFeat.panther -text "panther" -variable env(database_interpro.panther) -offvalue "-" -onvalue "+"
    checkbutton $t.showFeat.patternscan -text "patternscan" -variable env(database_interpro.patternscan) -offvalue "-" -onvalue "+"
    checkbutton $t.showFeat.pfam -text "pfam" -variable env(database_interpro.pfam) -offvalue "-" -onvalue "+"
    checkbutton $t.showFeat.pir -text "pir" -variable env(database_interpro.pir) -offvalue "-" -onvalue "+"
    checkbutton $t.showFeat.profilescan -text "profilescan" -variable env(database_interpro.profilescan) -offvalue "-" -onvalue "+"
    checkbutton $t.showFeat.smart -text "smart" -variable env(database_interpro.smart) -offvalue "-" -onvalue "+"
    checkbutton $t.showFeat.superfamily -text "superfamily" -variable env(database_interpro.superfamily) -offvalue "-" -onvalue "+"
    checkbutton $t.showFeat.tigr -text "tigr" -variable env(database_interpro.tigr) -offvalue "-" -onvalue "+"
    
    frame $t.location -bd 2 -relief groove
    label $t.location.label1 -text ""
    frame $t.location.server
    radiobutton $t.location.server.rb -text "Database server" -variable env(database_interpro.location) -value "server"
    entry $t.location.server.ent -background white -textvariable env(database_interpro.location_url) -width 30
    frame $t.location.local
    radiobutton $t.location.local.rb -text "Localhost: " -variable env(database_interpro.location) -value "local"
    entry $t.location.local.ent -background white -textvariable env(database_interpro.location_path) -width 30
    $t.location.server.rb select
    
    set comm "database_interpro [.result.notebook1.nb raise]; destroy $t"
    frame $t.buts -bd 2 -relief groove
    button $t.buts.ok -text "OK" -command $comm
    button $t.buts.cancel -text "Cancel" -command "destroy $t"
    
    pack $t.ptitle.label -side left -anchor w -fill both
    pack $t.showFeat.blastprodom $t.showFeat.coil $t.showFeat.gene3d \
            $t.showFeat.panther $t.showFeat.patternscan $t.showFeat.pfam $t.showFeat.pir \
            $t.showFeat.profilescan $t.showFeat.smart $t.showFeat.superfamily $t.showFeat.tigr \
            -side top -anchor w
    pack $t.location.server.rb $t.location.server.ent -side left -expand 1 -anchor w
    pack $t.location.local.rb $t.location.local.ent -side left -expand 1 -anchor w
    pack $t.location.server $t.location.local -side top -anchor w
    pack $t.buts.ok $t.buts.cancel -side left -expand 1 -anchor c
    pack $t.ptitle $t.showFeat $t.location $t.buts -side top -anchor w
    
    wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
    raise $t
}

proc database_interpro {mode} {
    global env
    
    if {[lindex [split $mode _] 0] eq "prj" || $mode eq "dbb"} {
        set params ""
        if {$env(database_interpro.blastprodom) eq "+"} {
            append params " blastprodom"
        }
        if {$env(database_interpro.coil) eq "+"} {
            append params " coil"
        }
        if {$env(database_interpro.gene3d) eq "+"} {
            append params " gene3d"
        }
        if {$env(database_interpro.panther) eq "+"} {
            append params " hmmpanther"
        }
        if {$env(database_interpro.pfam) eq "+"} {
            append params " hmmpfam"
        }
        if {$env(database_interpro.pir) eq "+"} {
            append params " hmmpir"
        }
        if {$env(database_interpro.profilescan) eq "+"} {
            append params " profilescan"
        }
        if {$env(database_interpro.smart) eq "+"} {
            append params " hmmsmart"
        }
        if {$env(database_interpro.superfamily) eq "+"} {
            append params " superfamily"
        }
        if {$env(database_interpro.tigr) eq "+"} {
            append params " hmmtigr"
        }
        
        set tl ".result.notebook1.nb.f$mode.1.table.l"
        $tl finishediting
        
        set ipsL ""
        set delL ""
        set tmpString ""
        set stop 0
        set i 0
        
        while {$stop ne 1} {
            if {[lindex [$tl get $i] 0] eq 1} {
                lappend ipsL "[lindex [$tl get $i] 23] [lindex [$tl get $i] 24] [lindex [$tl get $i] 2]"
            } elseif {[lindex [$tl get $i] 0] eq ""} {
                set stop 1
            }
            incr i
        }
        unset tl
        
        if {$env(database_interpro.location) eq "server"} {
            set location $env(database_interpro.location_url)
        } else {
            set location $env(database_interpro.location_path)
        }
        
        if {$env(sequence_type) eq "nucleotide"} {
            set seq_type n
        } else {
            set seq_type p
        }
        
        if {$ipsL ne ""} {
            set ipsL [lsort $ipsL]
            
            set ::threadInterpro [thread::create {
                proc dbinterpro {host port user password parentDB location ipsL seq_type params processID mode mainThreadID phpThreadID} {
                    global ipr_result
                    
                    set ipr_result ""
                    set i 0
                    
                    foreach ips $ipsL {
                        incr i
                        returnResult $processID running "Running InterProScan for [lindex $ips 2]" [lindex $ips 1] "$ipr_result" $mainThreadID
                        returnResult $processID running "InterProScan...$i of [llength $ipsL]" [lindex $ips 1] "$ipr_result" $mainThreadID
                        if {$mode eq "server"} {
                            set out [dbinterpro_run_server [lindex $ips 1] [lindex $ips 0] $seq_type "$params" "$location" $mainThreadID $phpThreadID]
                            if {$out eq "1"} {
                                eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT functions.seqInfo('[lindex $ips 1]', '[lindex $ips 0]')"}}]
                            }
                        } else {
                            set out [dbinterpro_run_local [lindex $ips 1] [lindex $ips 0] $seq_type "$params" "$location" $mainThreadID $phpThreadID]
                        }
                    }
                    set out [regsub -all {["]} $out "'"]
                    if {$out eq 1} {
                        returnResult $processID finished "InterProScan...done" [lindex $ips 1] "$ipr_result" $mainThreadID
                    } else {
                        returnResult $processID error "InterProScan...error" [lindex $ips 1] "$ipr_result" $mainThreadID
                    }
                }
                
                proc dbinterpro_run_local {dbName id_seq seq_type params path mainThreadID phpThreadID} {
                    global ipr_result
                    
                    if {$seq_type eq "n"} {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT name, sequence FROM $dbName.sequences_nucleotide WHERE id_seq = '$id_seq'"}}]]
                    } else {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT name, sequence FROM $dbName.sequences_protein WHERE id_prot = '$id_seq'"}}]]
                    }
                    foreach ent $sql_res {
                        set name [lindex $ent 0]
                        set sequence [lindex $ent 1]
                    }
                    
                    set out 1
                    set str ""
                    set ipsHitL ""
                    set comm "-cli -format raw -seqtype $seq_type -iprlookup -goterms"
                    if {$params ne ""} {
                        foreach p $params {
                            append comm " -appl $p"
                        }
                        set f "ipr_$dbName$id_seq.fas"
                        append comm " -i \"$path/tmp/$f\" -iprlookup -goterms"
                        
                        set ft [open $path/tmp/$f w]
                        close $ft
                        file attributes $path/tmp/$f -permissions rw-rw-rw-
                        set ft [open $path/tmp/$f w]
                        puts $ft ">$name\n$sequence"
                        close $ft
                        catch {[eval exec $path/bin/iprscan "$comm"]} out
                        set out "{[regsub -all {[\n]} $out "} {"]}"
                        append ipr_result "[lindex $id_seq 0] $name - $out.\n"
                        
                        foreach line $out {
                            if {[lindex $line 0] eq "SUBMITTED"} {
                                set folder [lindex $line 1]
                                set date [lindex [split $folder -] 1]
                                eval [subst {thread::send $mainThreadID {::database_protein_add $path/tmp/$date/$folder/[lindex $line 1].input 1}}]
                            }
                        }
                        eval [subst {thread::send $mainThreadID {::database_interproRes_add $path/tmp/$date/$folder/merged.raw}}]
                        
                        catch {file delete $path/tmp/$f}
                        catch {file delete -force $path/tmp/$date/$folder}
                        catch {file delete $path/tmp/$date}
                    }
                    return $out
                }
                
                proc dbinterpro_run_server {dbName id_seq seq_type params url mainThreadID phpThreadID} {
                    package require http
                    
                    global ipr_result
                    
                    set out 1
                    if {$seq_type eq "n"} {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT name, sequence FROM $dbName.sequences_nucleotide WHERE id_seq = '$id_seq'"}}]]
                    } else {
                        set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT name, sequence FROM $dbName.sequences_protein WHERE id_prot = '$id_seq'"}}]]
                    }
                    foreach sRes $sql_res {
                        set query [lindex $sRes 0]
                        set sequence [lindex $sRes 1]
                    }
                    puts "$query\n$sequence"
                    unset sql_res
                    set locationURL ""
                    
                    set que "tool=iprscan&goterms=1&iprlookup=1&seqtype=$seq_type&crc=1&cmd=submit"
                    if {$params ne ""} {
                        foreach p $params {
                            append que "&appl=$p"
                        }
                    }
                    append que "&sequence="
                    
                    set que2 [::http::formatQuery >$query\n$sequence]
                    set res ""
                    set i 0
                    while {$i < 10} {
                        if {[catch {set token [::http::geturl $url -query "$que$que2" -timeout 25000]}]} {
                            sleep 5000
                            incr i
                        } else {
                            set res [::http::meta $token]
                            puts "############META\n$res\n"
                            set res [::http::data $token]
                            puts "############DATA\n$res\n"
                            set res [::http::status $token]
                            puts "############STATUS\n$res\n"
                            set res [::http::code $token]
                            puts "############CODE\n$res\n"
                            set get 0
                            puts $res
                            foreach ent $res {
                                if {$ent eq "Location"} {
                                    set get 1
                                } elseif {$get} {
                                    set locationURL $ent
                                    set jobID [lindex [split $ent =] end]
                                    break
                                }
                            }
                            set i 10
                        }
                    }
                    catch {http::cleanup $token}
                    if {$locationURL ne ""} {
                        set complete 0
                        while {$complete eq 0} {
                            if {[catch {set token [http::geturl $locationURL -timeout 25000]}]} {
                                sleep 25000
                            } else {
                                set res [regsub -all {["\{\}\[\]]} [::http::data $token] ""]
                                http::cleanup $token
                                set meta 0
                                foreach ent $res {
                                    if {$ent eq "<meta"} {
                                        set meta 1
                                    } elseif {$meta} {
                                        if {$ent eq "HTTP-EQUIV=REFRESH"} {
                                            sleep 15000
                                            break
                                        } else {
                                            set complete 1
                                            break
                                        }
                                    }
                                }
                            }
                        }
                        catch {http::cleanup $token}
                        set res "{[regsub -all {[\n]} $res "} {"]}"
                        foreach line $res {
                            if {[lindex $line 0] eq "<form" && [lindex $line 1] eq "method=GET"} {
                                set resultURL [lindex [split [lindex $line 2] =] end]
                                set resultURL [string range $resultURL 0 [expr [string length $resultURL] - 2]]
                                if {[lindex [split $resultURL .] end] eq "txt"} {
                                    set txt 1
                                    break
                                }
                            }
                        }
                        if {$txt} {
                            set inputURL "[string range $resultURL 0 [expr [string length $resultURL] - 4]]input"
                            set complete 0
                            while {$complete eq 0} {
                                if {[catch {set token [http::geturl $resultURL -timeout 25000]}]} {
                                    sleep 25000
                                } else {
                                    set res "{[regsub -all {[\n]} [::http::data $token] "} {"]}"
                                    http::cleanup $token
                                    append ipr_result "$id_seq $query - [llength $res] hits found.\n"
                                    set complete 1
                                    if {[llength $res] ne 0} {
                                        set resF [open [pwd]/$id_seq.raw w]
                                        foreach line $res {
                                            append res_out "$line\n"
                                        }
                                        puts -nonewline $resF $res_out
                                        close $resF
                                        unset res_out
                                    }
                                }
                            }
                            set complete 0
                            while {$complete eq 0} {
                                if {[catch {set token [http::geturl $inputURL -timeout 25000]}]} {
                                    sleep 25000
                                } else {
                                    set res [::http::data $token]
                                    http::cleanup $token
                                    set complete 1
                                    if {[llength $res] ne 0} {
                                        set resF [open [pwd]/$id_seq.input w]
                                        puts -nonewline $resF $res
                                        close $resF
                                    }
                                }
                            }
                            catch {http::cleanup $token}
                            unset res
                            
                            eval [subst {thread::send $mainThreadID {::database_protein_add [pwd]/$id_seq.input 1}}]
                            eval [subst {thread::send $mainThreadID {::database_interproRes_add [pwd]/$id_seq.raw}}]
                            catch {file delete [pwd]/$id_seq.raw}
                            catch {file delete [pwd]/$id_seq.input}
                        } else {
                            append ipr_result "$id_seq $query - Error: Could not find result file.\n"
                            set out 0
                        }
                    } else {
                        append ipr_result "$id_seq $query - Error: Could not get result page.\n"
                        set out 0
                    }
                    return $out
                }
                
                proc sleep {time} {
                    global end
                    set end 0
                    after $time set end 1
                    vwait end
                }
                
                proc returnResult {processID status process dbName result mainThreadID} {
                    eval [subst {thread::send -async $mainThreadID {::process_update $processID $status "$process" $dbName "$result"}}]
                }
                thread::wait
            }]
            set processID [llength $env(processL)]
            process_update $processID running "InterProScan..." $env(dbName) 0
            eval [subst {thread::send -async $::threadInterpro {dbinterpro $env(host) $env(port) $env(user) $env(password) $env(parentDB) \"$location\" \"$ipsL\" $seq_type \"$params\" $processID $env(database_interpro.location) $env(mainThreadID) $env(phpThreadID)}}]
        }
        unset ipsL
    } else {
        errorPopUp "Error" "InterProScan is only available from the 'Database browser'\nor any kind of project tab."
    }
}

proc update_info_ips {} {
    global env
    .result.notebook2.nb.fips.0.label1 configure -text $env(contig.name)
    fillTable .result.notebook2.nb.fips.1.table.l 0 0
}

proc update_info_ips_table {name start end row} {
    global env
    global tabArr
    if {[.result.notebook1.nb raise] eq "sb" && $start ne "" && $row ne ""} {
        set seqRow [expr $row + 1]
        foreach prot $env(contig.proteinL) {
            if {[lindex $prot 5] eq $name} {
                set fr [lindex $prot 0]
                set protSeq [lindex $prot 6]
            }
        }
        set pos [translateNuc $env(contig.sequence) $protSeq $fr]
        if {$fr eq 1 || $fr eq 2 || $fr eq 3 || $fr eq "+"} {
            set nstart [lindex $pos 0]
            set nend [lindex $pos 1]
        } else {
            set nstart [expr [string length $env(contig.sequence)] - [lindex $pos 1]]
            set nend [expr [string length $env(contig.sequence)] - [lindex $pos 0]]
        }
        catch {.result.notebook1.nb.fsb.1.panel tag remove markedGreen 1.0 1000.end}
        catch {.result.notebook1.nb.fsb.1.panel tag remove markedOrange 1.0 1000.end}
        .result.notebook1.nb.fsb.1.panel tag add markedGreen $seqRow.0 $seqRow.end
        .result.notebook1.nb.fsb.1.panel tag add markedGreen 2.$nstart 2.$nend
        if {$start ne "N/A"} {
            if {$start > $end} {
                .result.notebook1.nb.fsb.1.panel tag add markedOrange $seqRow.$end $seqRow.$start
                .result.notebook1.nb.fsb.1.panel tag add markedOrange 2.[expr 3 * $end + $nstart] 2.[expr 3 * $start + $nstart]
            } else {
                .result.notebook1.nb.fsb.1.panel tag add markedOrange $seqRow.$start $seqRow.$end
                .result.notebook1.nb.fsb.1.panel tag add markedOrange 2.[expr 3 * $start + $nstart] 2.[expr 3 * $end + $nstart]
            }
        }
    }
}

proc interpro_config {} {
    global env
    
    set t .interproscan_results_config
    toplevel $t
    wm title $t "Interproscan Results Configuration"
    wm resizable $t 0 0
    wm attributes $t -topmost 1
    
    frame $t.show
    
    frame $t.show.showColumn -bd 2 -relief groove
    label $t.show.showColumn.label -text "Columns displayed: "
    checkbutton $t.show.showColumn.protname -text "prot name" -variable env(interproscan_results.protname) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.feat -text "feature" -variable env(interproscan_results.feat) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.description -text "description" -variable env(interproscan_results.description) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.start -text "start" -variable env(interproscan_results.start) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.end -text "end" -variable env(interproscan_results.end) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.length -text "length" -variable env(interproscan_results.length) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showColumn.evalue -text "evalue" -variable env(interproscan_results.evalue) -offvalue "-" -onvalue "+"
    
    frame $t.show.showFeat -bd 2 -relief groove
    label $t.show.showFeat.label -text "Features displayed: "
    checkbutton $t.show.showFeat.blastprodom -text "blastprodom" -variable env(interproscan_results.blastprodom) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showFeat.coil -text "coil" -variable env(interproscan_results.coil) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showFeat.gene3d -text "gene3d" -variable env(interproscan_results.gene3d) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showFeat.go -text "go" -variable env(interproscan_results.go) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showFeat.interpro -text "interpro" -variable env(interproscan_results.interpro) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showFeat.panther -text "panther" -variable env(interproscan_results.panther) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showFeat.patternscan -text "patternscan" -variable env(interproscan_results.patternscan) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showFeat.pfam -text "pfam" -variable env(interproscan_results.pfam) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showFeat.pir -text "pir" -variable env(interproscan_results.pir) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showFeat.profilescan -text "profilescan" -variable env(interproscan_results.profilescan) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showFeat.smart -text "smart" -variable env(interproscan_results.smart) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showFeat.superfamily -text "superfamily" -variable env(interproscan_results.superfamily) -offvalue "-" -onvalue "+"
    checkbutton $t.show.showFeat.tigr -text "tigr" -variable env(interproscan_results.tigr) -offvalue "-" -onvalue "+"
    
    frame $t.buts -bd 2 -relief groove
    button $t.buts.ok -text "Set" -command "interpro_changeConfig; destroy $t"
    button $t.buts.cancel -text "Cancel" -command "destroy $t"
    
    pack $t.show.showColumn.label $t.show.showColumn.protname $t.show.showColumn.feat $t.show.showColumn.description $t.show.showColumn.start \
            $t.show.showColumn.end $t.show.showColumn.length $t.show.showColumn.evalue -side top -anchor w
    pack $t.show.showFeat.label $t.show.showFeat.blastprodom $t.show.showFeat.coil $t.show.showFeat.gene3d \
            $t.show.showFeat.go $t.show.showFeat.interpro $t.show.showFeat.panther $t.show.showFeat.patternscan \
            $t.show.showFeat.pfam $t.show.showFeat.pir $t.show.showFeat.profilescan $t.show.showFeat.smart \
            $t.show.showFeat.superfamily $t.show.showFeat.tigr -side top -anchor w
    pack $t.show.showColumn $t.show.showFeat -side left -fill both
    pack $t.buts.ok $t.buts.cancel -side left -fill both
    pack $t.show $t.buts -side top -fill both
    
    wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
    raise $t
}

proc interpro_changeConfig {} {
    global env
    
    if {$env(interproscan_results.protname) eq "+"} {
        .result.notebook2.nb.fips.1.table.l columnconfigure 1 -hide no
    } else {
        .result.notebook2.nb.fips.1.table.l columnconfigure 1 -hide yes
    }
    if {$env(interproscan_results.feat) eq "+"} {
        .result.notebook2.nb.fips.1.table.l columnconfigure 2 -hide no
    } else {
        .result.notebook2.nb.fips.1.table.l columnconfigure 2 -hide yes
    }
    if {$env(interproscan_results.description) eq "+"} {
        .result.notebook2.nb.fips.1.table.l columnconfigure 4 -hide no
    } else {
        .result.notebook2.nb.fips.1.table.l columnconfigure 4 -hide yes
    }
    if {$env(interproscan_results.start) eq "+"} {
        .result.notebook2.nb.fips.1.table.l columnconfigure 5 -hide no
    } else {
        .result.notebook2.nb.fips.1.table.l columnconfigure 5 -hide yes
    }
    if {$env(interproscan_results.end) eq "+"} {
        .result.notebook2.nb.fips.1.table.l columnconfigure 6 -hide no
    } else {
        .result.notebook2.nb.fips.1.table.l columnconfigure 6 -hide yes
    }
    if {$env(interproscan_results.length) eq "+"} {
        .result.notebook2.nb.fips.1.table.l columnconfigure 7 -hide no
    } else {
        .result.notebook2.nb.fips.1.table.l columnconfigure 7 -hide yes
    }
    if {$env(interproscan_results.evalue) eq "+"} {
        .result.notebook2.nb.fips.1.table.l columnconfigure 8 -hide no
    } else {
        .result.notebook2.nb.fips.1.table.l columnconfigure 8 -hide yes
    }
    
    if {[catch {set ft [open [pwd]/conf/interpro_tace.conf w]} ]} {
        puts "error"
    } else {
        puts $ft "Interproscan_results"
        puts $ft "$env(interproscan_results.protname) \
                $env(interproscan_results.length) \
                $env(interproscan_results.feat) \
                $env(interproscan_results.description) \
                $env(interproscan_results.start) \
                $env(interproscan_results.end) \
                $env(interproscan_results.evalue) \
                $env(interproscan_results.blastprodom) \
                $env(interproscan_results.coil) \
                $env(interproscan_results.gene3d) \
                $env(interproscan_results.go) \
                $env(interproscan_results.interpro) \
                $env(interproscan_results.panther) \
                $env(interproscan_results.patternscan) \
                $env(interproscan_results.pfam) \
                $env(interproscan_results.pir) \
                $env(interproscan_results.profilescan) \
                $env(interproscan_results.smart) \
                $env(interproscan_results.superfamily) \
                $env(interproscan_results.tigr)"
        puts $ft "InterProScan_path"
        puts $ft $env(database_interpro.location_path)
        puts $ft $env(database_interpro.location_url)
        close $ft
    }
}
        
proc rightmenu_interpro {mode feat id coord} {
    global env
    
    .rightmenu delete 0 end
    .rightmenu.hidemenuColumn delete 0 end
    .rightmenu.copymenu delete 0 end
    
    .rightmenu add command -label "Show all hits" -command "catch {search_right $feat $id}"
    .rightmenu add separator
    .rightmenu add cascade -label "Hide/Show column..." -menu .rightmenu.hidemenuColumn
    .rightmenu add separator
    .rightmenu add cascade -label "Hide/Show hits from..." -menu .rightmenu.hidemenuHit
    .rightmenu.hidemenuColumn add command -label "$env(interproscan_results.description) description" -command "table_col_sh .result.notebook2.nb.fips.1.table.l interproscan_results.description 4"
    .rightmenu.hidemenuColumn add command -label "$env(interproscan_results.end) end" -command "table_col_sh .result.notebook2.nb.fips.1.table.l interproscan_results.end 6"
    .rightmenu.hidemenuColumn add command -label "$env(interproscan_results.evalue) evalue" -command "table_col_sh .result.notebook2.nb.fips.1.table.l interproscan_results.evalue 8"
    .rightmenu.hidemenuColumn add command -label "$env(interproscan_results.feat) feature" -command "table_col_sh .result.notebook2.nb.fips.1.table.l interproscan_results.feat 2"
    .rightmenu.hidemenuColumn add command -label "$env(interproscan_results.length) length" -command "table_col_sh .result.notebook2.nb.fips.1.table.l interproscan_results.length 7"
    .rightmenu.hidemenuColumn add command -label "$env(interproscan_results.protname) prot name" -command "table_col_sh .result.notebook2.nb.fips.1.table.l interproscan_results.protname 1"
    .rightmenu.hidemenuColumn add command -label "$env(interproscan_results.start) start" -command "table_col_sh .result.notebook2.nb.fips.1.table.l interproscan_results.start 5"
    
    .rightmenu.hidemenuHit add command -label "$env(interproscan_results.blastprodom) blastprodom" -command "table_col_sh - interproscan_results.blastprodom -; catch {update_info_get_name [.result.notebook2.nb.fips.0.label1 cget -text]}"
    .rightmenu.hidemenuHit add command -label "$env(interproscan_results.coil) coil" -command "table_col_sh - interproscan_results.coil -; catch {update_info_get_name [.result.notebook2.nb.fips.0.label1 cget -text]}"
    .rightmenu.hidemenuHit add command -label "$env(interproscan_results.gene3d) gene3d" -command "table_col_sh - interproscan_results.gene3d -; catch {update_info_get_name [.result.notebook2.nb.fips.0.label1 cget -text]}"
    .rightmenu.hidemenuHit add command -label "$env(interproscan_results.go) go" -command "table_col_sh - interproscan_results.go -; catch {update_info_get_name [.result.notebook2.nb.fips.0.label1 cget -text]}"
    .rightmenu.hidemenuHit add command -label "$env(interproscan_results.interpro) interpro" -command "table_col_sh - interproscan_results.interpro -; catch {update_info_get_name [.result.notebook2.nb.fips.0.label1 cget -text]}"
    .rightmenu.hidemenuHit add command -label "$env(interproscan_results.panther) panther" -command "table_col_sh - interproscan_results.panther -; catch {update_info_get_name [.result.notebook2.nb.fips.0.label1 cget -text]}"
    .rightmenu.hidemenuHit add command -label "$env(interproscan_results.patternscan) patternscan" -command "table_col_sh - interproscan_results.patternscan -; catch {update_info_get_name [.result.notebook2.nb.fips.0.label1 cget -text]}"
    .rightmenu.hidemenuHit add command -label "$env(interproscan_results.pfam) pfam" -command "table_col_sh - interproscan_results.pfam -; catch {update_info_get_name [.result.notebook2.nb.fips.0.label1 cget -text]}"
    .rightmenu.hidemenuHit add command -label "$env(interproscan_results.pir) pir" -command "table_col_sh - interproscan_results.pir -; catch {update_info_get_name [.result.notebook2.nb.fips.0.label1 cget -text]}"
    .rightmenu.hidemenuHit add command -label "$env(interproscan_results.profilescan) profilescan" -command "table_col_sh - interproscan_results.profilescan -; catch {update_info_get_name [.result.notebook2.nb.fips.0.label1 cget -text]}"
    .rightmenu.hidemenuHit add command -label "$env(interproscan_results.smart) smart" -command "table_col_sh - interproscan_results.smart -; catch {update_info_get_name [.result.notebook2.nb.fips.0.label1 cget -text]}"
    .rightmenu.hidemenuHit add command -label "$env(interproscan_results.superfamily) superfamily" -command "table_col_sh - interproscan_results.superfamily -; catch {update_info_get_name [.result.notebook2.nb.fips.0.label1 cget -text]}"
    .rightmenu.hidemenuHit add command -label "$env(interproscan_results.tigr) tigr" -command "table_col_sh - interproscan_results.tigr -; catch {update_info_get_name [.result.notebook2.nb.fips.0.label1 cget -text]}"
    .rightmenu add separator
    .rightmenu add cascade -label "Copy..." -menu .rightmenu.copymenu
    .rightmenu.copymenu add command -label "Cell" -command "catch {table_copy \"cell [lindex $coord 0] [lindex $coord 1]\" .result.notebook2.nb.fips.1.table.l}"
    .rightmenu.copymenu add command -label "Column" -command "catch {table_copy \"column [lindex $coord 0]\" .result.notebook2.nb.fips.1.table.l}"
    .rightmenu.copymenu add command -label "Row" -command "catch {table_copy \"row [lindex $coord 1]\" .result.notebook2.nb.fips.1.table.l}"
    .rightmenu.copymenu add command -label "Table" -command "catch {table_copy all .result.notebook2.nb.fips.1.table.l}"
    
    tk_popup .rightmenu [winfo pointerx .] [winfo pointery .]
}