proc menu_init {} {
    global env
    
    ###FILE
    menubutton .menubar.file -text File -underline 0 -menu .menubar.file.menu; pack .menubar.file -side left
    menu .menubar.file.menu
    .menubar.file.menu add command -label "Log in..." -command "database_login_window"
    .menubar.file.menu add separator
    .menubar.file.menu add command -label "New DB..." -command "database_create_window" -state normal
    .menubar.file.menu add cascade -label "Select DB" -menu .menubar.file.menu.fmenu
    menu .menubar.file.menu.fmenu
    .menubar.file.menu add separator
    .menubar.file.menu add command -label "New project..." -command "project_create"
    .menubar.file.menu add command -label "Open project" -command "project_open"
    .menubar.file.menu add command -label "Save project" -command "project_save 0"
    .menubar.file.menu add separator
    .menubar.file.menu add command -label "Delete selected DB" -command "database_delete_window" -state disabled
    .menubar.file.menu add separator
    .menubar.file.menu add cascade -label "Export..." -menu .menubar.file.menu.exportmenu -state disabled
    .menubar.file.menu add separator
    .menubar.file.menu add command -label "Save config" -command "config_save"
    .menubar.file.menu add command -label "Load config" -command "config_load"
    .menubar.file.menu add separator
    menu .menubar.file.menu.exportmenu
    .menubar.file.menu.exportmenu add command -label "export database" -command "database_export_window db"
    #.menubar.file.menu.exportmenu add command -label "export to ACE file" -command "database_export_window ace"
    .menubar.file.menu add cascade -label "Import..." -menu .menubar.file.menu.importmenu
    menu .menubar.file.menu.importmenu
    .menubar.file.menu.importmenu add command -label "import database" -command "database_import_window db"
    .menubar.file.menu.importmenu add command -label "import from ACE file" -command "database_import_window ace"
    .menubar.file.menu add separator
    .menubar.file.menu add command -label Quit -command exit
    
    ###EDIT
    menubutton .menubar.edit -text "Edit" -underline 0 -menu .menubar.edit.menu; pack .menubar.edit -side left
    menu .menubar.edit.menu
    .menubar.edit.menu add cascade -label "Add sequences..." -menu .menubar.edit.menu.asmenu; menu .menubar.edit.menu.asmenu
    .menubar.edit.menu add command -label "Remove selected sequences" -command "sequences_remove"
    .menubar.edit.menu add cascade -label "Save..." -menu .menubar.edit.menu.savemenu; menu .menubar.edit.menu.savemenu
    .menubar.edit.menu.savemenu add command -label "selected blast results" -command "sequences_save 0 0 0 blast_results 0"
    .menubar.edit.menu.savemenu add command -label "selected hits" -command "sequences_save 0 0 0 hits 0"
    .menubar.edit.menu.savemenu add command -label "selected sequences" -command "sequences_save 0 0 0 sequences 0"
    .menubar.edit.menu add cascade -label "Show..." -menu .menubar.edit.menu.showmenu; menu .menubar.edit.menu.showmenu
    .menubar.edit.menu.showmenu add command -label "selected blast results" -command "sequences_show blast_results"
    .menubar.edit.menu.showmenu add command -label "selected hits" -command "sequences_show hits"
    .menubar.edit.menu.showmenu add command -label "selected sequences" -command "sequences_show sequences"
    .menubar.edit.menu add command -label "Invert selection" -command "selection_invert"
    .menubar.edit.menu add separator
    .menubar.edit.menu add cascade -label "Sequence mode" -menu .menubar.edit.menu.smmenu; menu .menubar.edit.menu.smmenu
    .menubar.edit.menu.smmenu add command -label "Nucleotide" -command "set env(sequence_type) nucleotide; .status.lab2 configure -text \"Mode: nucleotide\"; get_seq_info all seq_info; database_browser_showSeq 0"
    .menubar.edit.menu.smmenu add command -label "Protein" -command "set env(sequence_type) protein; .status.lab2 configure -text \"Mode: protein\"; get_prot_info all prot_info; database_browser_showSeq 0"
    .menubar.edit.menu add separator
    .menubar.edit.menu add cascade -label "Edit DB..." -menu .menubar.edit.menu.adbmenu -state disabled; menu .menubar.edit.menu.adbmenu
    .menubar.edit.menu.adbmenu add command -label "Change comment" -command "database_comment_change_window"
    .menubar.edit.menu.adbmenu add command -label "Create database copy" -command "database_copy_window"
    .menubar.edit.menu.adbmenu add command -label "New nucleotide sequence" -command "database_nucleotide_new_window - -"
    .menubar.edit.menu.adbmenu add command -label "Translate contigs to proteins" -command "database_nuc2prot_window"
    .menubar.edit.menu.adbmenu add separator
    .menubar.edit.menu.adbmenu add cascade -label "Import sequences..." -menu .menubar.edit.menu.adbmenu.addseqmenu; menu .menubar.edit.menu.adbmenu.addseqmenu
    .menubar.edit.menu.adbmenu.addseqmenu add command -label "Add ACE file" -command "database_ACE_add_window"
    .menubar.edit.menu.adbmenu.addseqmenu add command -label "Add SAM file" -command "database_SAM_add_window"
    .menubar.edit.menu.adbmenu.addseqmenu add command -label "Add nucleotide file" -command "database_nucleotide_add_window"
    .menubar.edit.menu.adbmenu.addseqmenu add command -label "Add protein file" -command "database_protein_add_window"
    .menubar.edit.menu.adbmenu add cascade -label "Import annotations..." -menu .menubar.edit.menu.adbmenu.addannotmenu; menu .menubar.edit.menu.adbmenu.addannotmenu
    .menubar.edit.menu.adbmenu.addannotmenu add command -label "Blast results" -command "database_blastResult_add_window"
    .menubar.edit.menu.adbmenu.addannotmenu add command -label "GO terms" -command "database_GOTerms_add_window"
    .menubar.edit.menu.adbmenu.addannotmenu add command -label "InterProScan results" -command "database_interproRes_add_window"
    .menubar.edit.menu.adbmenu.addannotmenu add command -label "PolyA information" -command "database_polyA_add_window"
    .menubar.edit.menu.adbmenu add separator
    .menubar.edit.menu.adbmenu add command -label "Delete selected contigs" -command "database_contig_delete_window"
    .menubar.edit.menu.adbmenu add command -label "Delete selected hits" -command "database_hits_delete_window"
    .menubar.edit.menu.adbmenu add separator
    .menubar.edit.menu.adbmenu add cascade -label "Update..." -menu .menubar.edit.menu.adbmenu.umenu; menu .menubar.edit.menu.adbmenu.umenu
    .menubar.edit.menu.adbmenu.umenu add command -label "general" -command "database_update general 0"
    .menubar.edit.menu.adbmenu.umenu add separator
    .menubar.edit.menu.adbmenu.umenu add command -label "blast2interpro entries" -command "database_update_window blast2interpro"
    .menubar.edit.menu.adbmenu.umenu add command -label "coverage" -command "database_update coverage 0"
    .menubar.edit.menu.adbmenu.umenu add command -label "database info" -command "database_update dbInfo 0"
    .menubar.edit.menu.adbmenu.umenu add command -label "domain2interpro entries" -command "database_update domain2interpro 0"
    .menubar.edit.menu.adbmenu.umenu add command -label "GO-Statistic" -command "database_update gostat 0"
    .menubar.edit.menu.adbmenu.umenu add command -label "KEGG-Maps" -command "database_update kegg 0"
    .menubar.edit.menu.adbmenu.umenu add command -label "protein descriptions" -command "database_update_window description_prot"
    .menubar.edit.menu.adbmenu.umenu add command -label "protein entries" -command "database_update protInfo 0"
    .menubar.edit.menu.adbmenu.umenu add command -label "read distribution" -command "database_update readDistribution 0"
    .menubar.edit.menu.adbmenu.umenu add command -label "read status" -command "database_update readStatus 0"
    .menubar.edit.menu.adbmenu.umenu add command -label "sequence descriptions" -command "database_update_window description_seq"
    .menubar.edit.menu.adbmenu.umenu add command -label "sequence entries" -command "database_update seqInfo 0"   
    ###MODULES
    menubutton .menubar.module -text "Modules" -underline 0 -menu .menubar.module.menu; pack .menubar.module -side left
    menu .menubar.module.menu
    .menubar.module.menu add command -label "Add/Remove..." -command "menu_configure_modules"
    .menubar.module.menu add separator
    
    ###TOOLS
    menubutton .menubar.tool -text "Tools" -underline 0 -menu .menubar.tool.menu; pack .menubar.tool -side left
    menu .menubar.tool.menu
    .menubar.tool.menu add command -label "Search" -command "search_window"
    .menubar.tool.menu add separator
    
    ###CONFIG
    menubutton .menubar.config -text "Config" -underline 0 -menu .menubar.config.menu; pack .menubar.config -side left
    menu .menubar.config.menu
    .menubar.config.menu add command -label "Change user password" -command "database_password_change_window"
    .menubar.config.menu add command -label "Database connections" -command "config_database"
    .menubar.config.menu add command -label "Set BrowserPath" -command "browse setBrowser {{{Browser executable} {.exe} } {{All Files} * }} -"
    .menubar.config.menu add command -label "Set HomeFolder" -command "browse setHome - -"
    .menubar.config.menu add command -label "Set InterProScanFolder" -command "browse setIPR - -"
    .menubar.config.menu add command -label "Set ProteinTranslationTable" -command "browse setTranslateTableProtPath {{{TranslationTable executable} {.txt} } {{All Files} * }} -"
    .menubar.config.menu add separator
    .menubar.config.menu add command -label "Tabs" -command "config_tabs"
    .menubar.config.menu add separator
    .menubar.config.menu add command -label "Save configuration" -command "config_change all"
    .menubar.config.menu add command -label "Refresh configuration" -command "config_refresh"
    .menubar.config.menu add separator
    .menubar.config.menu add command -label "Database browser" -command "config_database_browser"
    .menubar.config.menu add command -label "Database info" -command "config_database_info"
    
    ###TABS
    menubutton .menubar.tab -text "Tabs" -underline 0 -menu .menubar.tab.menu; pack .menubar.tab -side left
    menu .menubar.tab.menu
    .menubar.tab.menu add command -label "Process" -command "catch {create_tab process}"
    
    ###HELP
    menubutton .menubar.help -text "Help" -underline 0 -menu .menubar.help.menu; pack .menubar.help -side right
    menu .menubar.help.menu
    .menubar.help.menu add command -label "Help..." -command "catch {help}"
    .menubar.help.menu add command -label "About..." -command "catch {about_window}"
}