proc phobos_init {} {
    global env
    global checkedImg
    global uncheckedImg
    global closeImg
    
    global phobos_searchmode
    global phobos_indelScore
    global phobos_mismatchScore
    global phobos_minScore
    global phobos_minLength
    global phobos_maxUnitLen
    global phobos_minUnitLen
    global phobos_recursion
    global phobos_dontRemoveMostlyOverlapping
    global phobos_minPerfection
    global phobos_NPerfectionMode
    global phobos_NsAsMissense
    global phobos_succN
    
    
    #Creating menu buttons
    .menubar.config.menu add command -label "Repeats" -command "phobos_config"
    .menubar.tool.menu add command -label "Phobos" -command "phobos_window - all"
    .menubar.tab.menu add command -label "Repeats" -command "catch {create_tab repeat}"
    
    if {[catch {set ft [open [pwd]/conf/phobos_tace.conf r]} ]} {
        #Phobos Parameters
        set phobos_searchmode "imperfect"
        set phobos_indelScore -6
        set phobos_mismatchScore -6
        set phobos_minScore 0
        set phobos_minLength 1
        set phobos_maxUnitLen 5
        set phobos_minUnitLen 2
        set phobos_recursion 4
        set phobos_dontRemoveMostlyOverlapping 1
        set phobos_minPerfection 90.0
        set phobos_NPerfectionMode mismatch
        set phobos_NsAsMissense 0
        set phobos_succN 2
        #Repeats
        set env(repeat.unitLength) "+"
        set env(repeat.unit) "+"
        set env(repeat.start) "+"
        set env(repeat.end) "+"
        set env(repeat.length) "+"
        set env(repeat.score) "+"
        set env(repeat.perfection) "+"
        set env(repeat.mismatches) "+"
        set env(repeat.insertions) "+"
        set env(repeat.deletions) "+"
        set env(repeat.numOfNs) "+"
    } else {
        #Phobos Parameters
        gets $ft line
        gets $ft line
        set phobos_searchmode [lindex $line 0]
        set phobos_indelScore [lindex $line 1]
        set phobos_mismatchScore [lindex $line 2]
        set phobos_minScore [lindex $line 3]
        set phobos_minLength [lindex $line 4]
        set phobos_maxUnitLen [lindex $line 5]
        set phobos_minUnitLen [lindex $line 6]
        set phobos_recursion [lindex $line 7]
        set phobos_dontRemoveMostlyOverlapping [lindex $line 8]
        set phobos_minPerfection [lindex $line 9]
        set phobos_NPerfectionMode [lindex $line 10]
        set phobos_NsAsMissense [lindex $line 11]
        set phobos_succN [lindex $line 12]
        #Repeats
        gets $ft line
        gets $ft line
        set env(repeat.unitLength) [lindex $line 0]
        set env(repeat.unit) [lindex $line 1]
        set env(repeat.start) [lindex $line 2]
        set env(repeat.end) [lindex $line 3]
        set env(repeat.length) [lindex $line 4]
        set env(repeat.score) [lindex $line 5]
        set env(repeat.perfection) [lindex $line 6]
        set env(repeat.mismatches) [lindex $line 7]
        set env(repeat.insertions) [lindex $line 8]
        set env(repeat.deletions) [lindex $line 9]
        set env(repeat.numOfNs) [lindex $line 10]
    }
    
    set notebook .result.notebook2.nb
    set frame [$notebook insert end repeat -text "Repeats" -raisecmd "catch {update_info_repeat}"]
    frame $frame.0
    label $frame.0.label1 -font 12
    checkbutton $frame.0.list -text "List" -variable repeat_listCheck \
            -command {if {$repeat_listCheck} {repeat_list} else {catch {destroy .repeat_list}}}
    button $frame.0.exit -image $closeImg -highlightthickness 0 -takefocus 0 -command "::close_tab repeat"
    frame $frame.1
    frame $frame.1.table
    scrollbar $frame.1.y -orient vertical -command "$frame.1.table.l yview"
    scrollbar $frame.x -orient horizontal -command "$frame.1.table.l xview"
    set nb2_tl_repeat $frame.1.table.l
    tablelist::tablelist $nb2_tl_repeat \
            -width 10 -height 1 -showseparators 1 -stripebackground lightblue\
            -columns {
                0 "" 0 "unit length" 0 "unit" 0 "start" 0 "end" 0 "length" 0 "score" 0 "perfection" 0 "mismatches" \
                0 "insertions" 0 "deletions" 0 "num. of Ns" 0 "id_seq"} \
            -labelcommand "$nb2_tl_repeat finishediting; tablelist::sortByColumn" \
            -exportselection 0 \
            -selectmode single \
            -editendcommand editEndCmd \
            -yscrollcommand "$frame.1.y set" \
            -xscrollcommand "$frame.x set" \
            -background white
    $nb2_tl_repeat columnconfigure 0 \
            -sortmode integer \
            -editable yes \
            -editwindow checkbutton \
            -formatcommand emptystr \
            -labelimage [expr {1 ? $checkedImg : $uncheckedImg}] \
            -labelcommand "table_selection"
    
    $nb2_tl_repeat columnconfigure 12 -hide yes
    $nb2_tl_repeat columnconfigure 2 -sortmode dictionary
    
    if {$env(repeat.unitLength) eq "+"} {
        .result.notebook2.nb.frepeat.1.table.l columnconfigure 1 -hide no
    } else {
        .result.notebook2.nb.frepeat.1.table.l columnconfigure 1 -hide yes
    }
    if {$env(repeat.unit) eq "+"} {
        .result.notebook2.nb.frepeat.1.table.l columnconfigure 2 -hide no
    } else {
        .result.notebook2.nb.frepeat.1.table.l columnconfigure 2 -hide yes
    }
    if {$env(repeat.start) eq "+"} {
        .result.notebook2.nb.frepeat.1.table.l columnconfigure 3 -hide no
    } else {
        .result.notebook2.nb.frepeat.1.table.l columnconfigure 3 -hide yes
    }
    if {$env(repeat.end) eq "+"} {
        .result.notebook2.nb.frepeat.1.table.l columnconfigure 4 -hide no
    } else {
        .result.notebook2.nb.frepeat.1.table.l columnconfigure 4 -hide yes
    }
    if {$env(repeat.length) eq "+"} {
        .result.notebook2.nb.frepeat.1.table.l columnconfigure 5 -hide no
    } else {
        .result.notebook2.nb.frepeat.1.table.l columnconfigure 5 -hide yes
    }
    if {$env(repeat.score) eq "+"} {
        .result.notebook2.nb.frepeat.1.table.l columnconfigure 6 -hide no
    } else {
        .result.notebook2.nb.frepeat.1.table.l columnconfigure 6 -hide yes
    }
    if {$env(repeat.perfection) eq "+"} {
        .result.notebook2.nb.frepeat.1.table.l columnconfigure 7 -hide no
    } else {
        .result.notebook2.nb.frepeat.1.table.l columnconfigure 7 -hide yes
    }
    if {$env(repeat.mismatches) eq "+"} {
        .result.notebook2.nb.frepeat.1.table.l columnconfigure 8 -hide no
    } else {
        .result.notebook2.nb.frepeat.1.table.l columnconfigure 8 -hide yes
    }
    if {$env(repeat.insertions) eq "+"} {
        .result.notebook2.nb.frepeat.1.table.l columnconfigure 9 -hide no
    } else {
        .result.notebook2.nb.frepeat.1.table.l columnconfigure 9 -hide yes
    }
    if {$env(repeat.deletions) eq "+"} {
        .result.notebook2.nb.frepeat.1.table.l columnconfigure 10 -hide no
    } else {
        .result.notebook2.nb.frepeat.1.table.l columnconfigure 10 -hide yes
    }
    if {$env(repeat.numOfNs) eq "+"} {
        .result.notebook2.nb.frepeat.1.table.l columnconfigure 11 -hide no
    } else {
        .result.notebook2.nb.frepeat.1.table.l columnconfigure 11 -hide yes
    }
    
    pack $frame.1.table.l -side left -fill both -expand true
    pack $frame.1.y -side left -fill both; pack $frame.1.table -side left -fill both -expand true
    pack $frame.0.label1 -side left -fill both -anchor w; pack $frame.0.exit $frame.0.list -side right -fill both -anchor e
    pack $frame.0 -side top -fill both; pack $frame.1 -side top -fill both -expand true
    pack $frame.x -side top -fill both
    
    #Phobos rightmenu
    set tl .result.notebook2.nb.frepeat.1.table.l
    bind [$tl bodypath] <Button-3> "
    set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
    catch \{set coord \"\[expr {%x + \[winfo x %W\]}\] \[expr {%y + \[winfo y %W\]}\]\"\}
    set id \[lindex \[$tl get \$y\] 2\]
    rightmenu_phobos repeat repeat \$id \$coord
    "
}

proc phobos_remove {} {
    #Remove menu buttons
    .menubar.config.menu delete "Repeats"
    .menubar.tool.menu delete "Phobos"
    .menubar.tab.menu delete "Repeats"
    .result.notebook2.nb delete repeat
}

proc phobos_window {db id_seq} {
    global env
    global phobos_searchmode
    global phobos_indelScore
    global phobos_mismatchScore
    global phobos_minScore
    global phobos_minLength
    global phobos_maxUnitLen
    global phobos_minUnitLen
    global phobos_recursion
    global phobos_dontRemoveMostlyOverlapping
    global phobos_minPerfection
    global phobos_NPerfectionMode
    global phobos_NsAsMissense
    global phobos_succN
    
    variable phobos_searchmode
    variable phobos_indelScore
    variable phobos_mismatchScore
    variable phobos_minScore
    variable phobos_minLength
    variable phobos_maxUnitLen
    variable phobos_minUnitLen
    variable phobos_recursion
    variable phobos_dontRemoveMostlyOverlapping
    variable phobos_minPerfection
    variable phobos_NPerfectionMode
    variable phobos_NsAsMissense
    variable phobos_succN

    if {$env(dbName) ne " "} {
        if {[.result.notebook1.nb raise] ne "db_info" && [.result.notebook1.nb raise] ne "blast"  && [.result.notebook1.nb raise] ne "db_stat" && [.result.notebook1.nb raise] ne "sb" && [.result.notebook1.nb raise] ne "process"} {
            set t .phobos
            catch {destroy $t}
            toplevel $t
            wm title $t "Search for repeats (Phobos)"
            wm resizable $t 0 0
            wm attributes $t -topmost 1
            
            # Top "phobos parameters" control panel
            frame $t.params
            
            frame $t.params.searchmode
            label $t.params.searchmode.label -text "Search mode:"
            ComboBox $t.params.searchmode.cb -width 10 -hottrack 1 -background white -text $phobos_searchmode -values {exact extendExact imperfect}
            frame $t.params.indelScore
            label $t.params.indelScore.label -text "Score for indels:"
            entry $t.params.indelScore.ent -textvariable phobos_indelScore -width 5 -background white
            frame $t.params.mismatchScore
            label $t.params.mismatchScore.label -text "Score for mismatches:"
            entry $t.params.mismatchScore.ent -textvariable phobos_mismatchScore -width 5 -background white
            frame $t.params.minScore
            label $t.params.minScore.label -text "min. score:"
            entry $t.params.minScore.ent -textvariable phobos_minScore -width 5 -background white
            frame $t.params.minPerfection
            label $t.params.minPerfection.label -text "min. perfection:"
            entry $t.params.minPerfection.ent -textvariable phobos_minPerfection -width 5 -background white
            frame $t.params.minLength
            label $t.params.minLength.label -text "min. length:"
            entry $t.params.minLength.ent -textvariable phobos_minLength -width 5 -background white
            frame $t.params.minUnitLen
            label $t.params.minUnitLen.label -text "min. unit length:"
            entry $t.params.minUnitLen.ent -textvariable phobos_minUnitLen -width 5 -background white
            frame $t.params.maxUnitLen
            label $t.params.maxUnitLen.label -text "max. unit length:"
            entry $t.params.maxUnitLen.ent -textvariable phobos_maxUnitLen -width 5 -background white
            frame $t.params.recursion
            label $t.params.recursion.label -text "recursion depth: (3-7)"
            entry $t.params.recursion.ent -textvariable phobos_recursion -width 5 -background white
            frame $t.params.dontRemoveMostlyOverlapping
            checkbutton $t.params.dontRemoveMostlyOverlapping.check -text "don't remove overlapping" -variable phobos_dontRemoveMostlyOverlapping
            frame $t.params.nPerfectionMode
            label $t.params.nPerfectionMode.label -text "N-perfection mode:"
            ComboBox $t.params.nPerfectionMode.cb -width 10 -hottrack 1 -background white -text $phobos_NPerfectionMode -values {mismatch neutral match}
            frame $t.params.nsAsMissense
            checkbutton $t.params.nsAsMissense.check -text "N's as missense" -variable phobos_NsAsMissense
            frame $t.params.succN
            label $t.params.succN.label -text "max. successive Ns:"
            entry $t.params.succN.ent -textvariable phobos_succN -width 5 -background white
            
            #Packing top parameters
            pack $t.params.searchmode.label -side left; pack $t.params.searchmode.cb -side right
            pack $t.params.indelScore.label -side left; pack $t.params.indelScore.ent -side right
            pack $t.params.mismatchScore.label -side left; pack $t.params.mismatchScore.ent -side right
            pack $t.params.minScore.label -side left; pack $t.params.minScore.ent -side right
            pack $t.params.minPerfection.label -side left; pack $t.params.minPerfection.ent -side right
            pack $t.params.minLength.label -side left; pack $t.params.minLength.ent -side right
            pack $t.params.minUnitLen.label -side left; pack $t.params.minUnitLen.ent -side right
            pack $t.params.maxUnitLen.label -side left; pack $t.params.maxUnitLen.ent -side right
            pack $t.params.recursion.label -side left; pack $t.params.recursion.ent -side right
            pack $t.params.dontRemoveMostlyOverlapping.check -side left
            pack $t.params.nsAsMissense.check -side left
            pack $t.params.nPerfectionMode.label -side left; pack $t.params.nPerfectionMode.cb -side right
            pack $t.params.succN.label -side left; pack $t.params.succN.ent -side right
            
            pack $t.params.searchmode $t.params.indelScore $t.params.mismatchScore $t.params.minScore\
                    $t.params.minPerfection $t.params.minLength $t.params.minUnitLen\
                    $t.params.maxUnitLen $t.params.recursion $t.params.dontRemoveMostlyOverlapping\
                    $t.params.nsAsMissense $t.params.nPerfectionMode $t.params.succN -side top -fill both
            pack $t.params -side top -fill both
            
            set comm "phobos_run $db $id_seq"
            
            #The Buttons Ok, Close, Help and Save
            frame $t.buts -bd 2 -relief groove
            button $t.buts.okay -text "OK" -command "$comm; destroy $t"
            button $t.buts.cancel -text "Cancel" -command "destroy $t"
            button $t.buts.save -text "Save" -command "phobos_changeConfig phobosparams"
            pack $t.buts.okay $t.buts.cancel -side left; pack $t.buts.save -side right
            pack $t.buts -side bottom -fill both
            
            wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
            raise $t
        } else {
            ::errorPopUp "Error - Phobos" "Please select 'Database browser' or a project tab."
        }
    } else {
        ::errorPopUp "Error" "No database selected."
    }
}

proc phobos_run {db id_seq} {
    global env
    
    global phobos_searchmode
    global phobos_indelScore
    global phobos_mismatchScore
    global phobos_minScore
    global phobos_minLength
    global phobos_maxUnitLen
    global phobos_minUnitLen
    global phobos_recursion
    global phobos_dontRemoveMostlyOverlapping
    global phobos_minPerfection
    global phobos_NPerfectionMode
    global phobos_NsAsMissense
    global phobos_succN
    
    set phobos_searchmode [.phobos.params.searchmode.cb get]
    set phobos_indelScore [.phobos.params.indelScore.ent get]
    set phobos_mismatchScore [.phobos.params.mismatchScore.ent get]
    set phobos_minScore [.phobos.params.minScore.ent get]
    set phobos_minLength [.phobos.params.minLength.ent get]
    set phobos_maxUnitLen [.phobos.params.maxUnitLen.ent get]
    set phobos_minUnitLen [.phobos.params.minUnitLen.ent get]
    set phobos_recursion [.phobos.params.recursion.ent get]
    set phobos_minPerfection [.phobos.params.minPerfection.ent get]
    set phobos_NPerfectionMode [.phobos.params.nPerfectionMode.cb get]
    set phobos_succN [.phobos.params.succN.ent get]
    
    if {[.result.notebook1.nb raise] ne "db_info" && [.result.notebook1.nb raise] ne "blast"  && [.result.notebook1.nb raise] ne "db_stat" && [.result.notebook1.nb raise] ne "sb" && [.result.notebook1.nb raise] ne "process"} {
        if {$id_seq eq "all"} {
            set tl ".result.notebook1.nb.f[.result.notebook1.nb raise].1.table.l"
            $tl finishediting
            set idL ""
            set tmpString ""
            set stop 0
            set i 0
            while {$stop ne 1} {
                if {[lindex [$tl get $i] 0] eq 1} {
                    lappend idL "[lindex [$tl get $i] 23] [lindex [$tl get $i] 24]"
                } elseif {[lindex [$tl get $i] 0] eq ""} {
                    set stop 1
                }
                incr i
            }
            set idL [lsort -index 1 $idL]
        } else {
            set idL "{$id_seq $db}"
        }
        set phobos_param ""
        if {$idL ne ""} {
            if {$phobos_searchmode ne ""} {
                append phobos_param "-M $phobos_searchmode "
            }
            if {$phobos_indelScore ne ""} {
                append phobos_param "-g $phobos_indelScore "
            }
            if {$phobos_mismatchScore ne ""} {
                append phobos_param "-m $phobos_mismatchScore "
            }
            if {$phobos_minScore ne ""} {
                append phobos_param "-s $phobos_minScore "
            }
            if {$phobos_minLength ne ""} {
                append phobos_param "-l $phobos_minLength "
            }
            if {$phobos_maxUnitLen ne ""} {
                append phobos_param "-U $phobos_maxUnitLen "
            }
            if {$phobos_minUnitLen ne ""} {
                append phobos_param "-u $phobos_minUnitLen "
            }
            if {$phobos_recursion ne ""} {
                append phobos_param "-r $phobos_recursion "
            }
            if {$phobos_minPerfection ne ""} {
                #append phobos_param "-P $phobos_minPerfection "
            }
            if {$phobos_succN ne ""} {
                append phobos_param "-N $phobos_succN "
            }
            if {$phobos_NPerfectionMode eq "mismatch"} {
                append phobos_param "--NPerfectionMode 0 "
            } elseif {$phobos_NPerfectionMode eq "neutral"} {
                append phobos_param "--NPerfectionMode 1 "
            } elseif {$phobos_NPerfectionMode eq "match"} {
                append phobos_param "--NPerfectionMode 2 "
            }
            if {$phobos_dontRemoveMostlyOverlapping} {
                append phobos_param "-D "
            }
            if {$phobos_NsAsMissense} {
                append phobos_param "--NsAsMissense "
            }
            
            set ::threadPhobos [thread::create {
                proc phobos {idL phobos_param phpThreadID} {
                    global env
                    set db ""
                    set tmpString ""
                    foreach id $idL {
                        if {$db eq [lindex $id 1]} {
                            append tmpString ", '[lindex $id 0]'"
                        } elseif {$db eq ""} {
                            set tmpString ", '[lindex $id 0]'"
                            set db [lindex $id 1]
                        } else {
                            set tmpString [string range $tmpString 2 end]
                            set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_seq, sequence FROM $db.sequences_nucleotide WHERE id_seq IN ($tmpString)"}}]]
                            foreach sRes $sql_res {
                                append phobos_seqL ">[lindex $sRes 0] $db\n[lindex $sRes 1]\n"
                            }
                            unset sql_res
                            set tmpString ", '[lindex $id 0]'"
                            set db [lindex $id 1]
                        }
                    }
                    set tmpString [string range $tmpString 2 end]
                    set sql_res [eval [subst {thread::send $phpThreadID {::php_getSQLresults "SELECT id_seq, sequence FROM $db.sequences_nucleotide WHERE id_seq IN ($tmpString)"}}]]
                    foreach sRes $sql_res {
                        append phobos_seqL ">[lindex $sRes 0] $db\n[lindex $sRes 1]\n"
                    }
                    unset sql_res
                    unset tmpString
                    set ft [open $env(homeFolder)/phobos_input.txt w]
                    puts -nonewline $ft $phobos_seqL
                    close $ft
                    unset phobos_seqL
                    
                    #Running Phobos
                    if {$env(platform) == "windows"} {
                        set comm "phobos.exe $phobos_param $env(homeFolder)/phobos_input.txt"
                    } elseif {$env(platform) == "unix"} {
                        set comm "phobos-linux $phobos_param $env(homeFolder)/phobos_input.txt"
                    }
                    catch {eval exec $comm} phobos_result
                    catch {file delete $env(homeFolder)/phobos_input.txt}
                    
                    set phobos_result "{[regsub -all {\n} $phobos_result "\} \{"]}"
                    
                    set phobosL ""
                    set start 0
                    set err ""
                    foreach line $phobos_result {
                        if {[string index $line 0] eq ">"} {
                            set id_seq [string range [lindex $line 0] 1 end]
                            set db [lindex $line 1]
                            set start 1
                        } elseif {[string index $line 0] eq " " && $start}  {
                            set start [expr [lindex $line 1] - 1]
                            set end [expr [lindex $line 3] - 1]
                            lappend phobosL "$db {'$id_seq', '[string length [lindex $line 30]]', '[lindex $line 30]', \
                                        '$start', '$end', '[lindex $line 5]', '[lindex $line 11]', \
                                        '[lindex $line 14]', '[lindex $line 17]', '[lindex $line 20]', '[lindex $line 23]',\
                                        '[lindex $line 26]'}"
                        } elseif {[lindex $line 0] eq "##"} {
                            break
                        } elseif {$start eq 0} {
                            append err "$line\n"
                        }
                    }
                    if {$phobosL ne ""} {
                        #Writing Results to Database
                        foreach repeat $phobosL {
                            eval [subst {thread::send $phpThreadID {::php_getSQLresults "INSERT INTO [lindex $repeat 0].sequences_nucleotide_repeat VALUES ([lindex $repeat 1]);"}}]
                        }
                        unset idL
                        unset phobosL
                        unset phobos_result
                        eval [subst {thread::send -async $env(mainThreadID) {update_info_repeat}}]
                    } else {
                        puts $err
                    }
                }
                thread::wait
            }]
            eval [subst {thread::send -async $::threadPhobos {phobos \"$idL\" \"$phobos_param\" $env(phpThreadID)}}]
            catch {::create_tab repeats}
        }
    }
}

proc repeat_list {} {
    global repeat_listCheck
    
    set t .repeat_list
    toplevel $t
    wm title $t "Repeat list"
    wm attributes $t -topmost 1
    
    text $t.panel -background white -yscrollcommand "$t.y set"
    scrollbar $t.y -orient vertical -command "$t.panel yview"
    
    pack $t.panel -side left -fill both -expand true; pack $t.y -side left -fill both
}

proc update_info_repeat {} {
    global env
    
    set repeatL ""
    set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_seq, unit_length, unit, \\\"start\\\", \\\"end\\\", length, score, perfection, mismatches, insertions, deletions, num_of_ns FROM $env(contig.dbName).sequences_nucleotide_repeat WHERE id_seq = '$env(contig.id_seq)' ORDER BY \\\"start\\\""}}]]
    foreach sRes $sql_res {
        lappend repeatL "{[lindex $sRes 1]} {[lindex $sRes 2]} {[lindex $sRes 3]} {[lindex $sRes 4]} {[lindex $sRes 5]} {[lindex $sRes 6]} {[lindex $sRes 7]} {[lindex $sRes 8]} {[lindex $sRes 9]} {[lindex $sRes 10]} {[lindex $sRes 11]} [lindex $sRes 0]"
    }
    unset sql_res
    .result.notebook2.nb.frepeat.0.label1 configure -text $env(contig.name)
    fillTable_repeat "$repeatL"
}

proc fillTable_repeat {repeatL} {
    global checkedImg
    global uncheckedImg
    
    set tl .result.notebook2.nb.frepeat.1.table.l
    $tl finishediting
    if {[$tl columncget 0 -labelimage] eq "image1"} {
        set use 1
    } else {
        set use 0
    }
    
    $tl delete 0 end
    foreach ent $repeatL {
        $tl insert end "1 $ent"
        $tl cellconfigure end,0 -image [expr {1 ? $checkedImg : $uncheckedImg}]
    }
    
    # Bindings.
    bind [$tl bodypath] <Button-1> "
    set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
    set row \[lrange \[$tl get \$y\] 1 end\]
    update_info_repeat_table \$row
    "
}

proc update_info_repeat_table {row} {
    global tabArr
    global repeat_listCheck
    
    set contig [.result.notebook2.nb.frepeat.0.label1 cget -text]
    set unit_length [lindex $row 0]
    set unit [lindex $row 1]
    set start [lindex $row 2]
    set end [lindex $row 3]
    set length [lindex $row 4]
    set score [lindex $row 5]
    set perfection [lindex $row 6]
    set mismatch [lindex $row 7]
    set insertion [lindex $row 8]
    set deletion [lindex $row 9]
    set numOfNs [lindex $row 10]
    
    if {$tabArr(sb.exist) && $row ne ""} {
        set nucSeq [.result.notebook1.nb.fsb.1.panel get -displaychars 2.0 2.end]
        catch {.result.notebook1.nb.fsb.1.panel tag remove markedRed 1.0 1000.end}
        catch {.result.notebook1.nb.fsb.1.panel tag remove markedYellow 1.0 1000.end}
        .result.notebook1.nb.fsb.1.panel tag add markedYellow 2.$start 2.[expr $end + 1]
    }
    if {$repeat_listCheck} {
        if {[
            catch {
                .repeat_list.panel delete 1.0 end
                .repeat_list.panel insert end "Contig:\t$contig\n\
                        Unit length:\t$unit_length\n\
                        Unit:\t$unit\n\
                        Start:\t$start\n\
                        End:\t$end\n\
                        Length:\t$length\n\
                        Score:\t$score\n\
                        Perfection (%):\t$perfection\n\
                        Mismatches:\t$mismatch\n\
                        Insertions:\t$insertion\n\
                        Deletions:\t$deletion\n\
                        Num. of N's:\t$numOfNs"
            }
            ]} {
            set repeat_listCheck 0
        }
    }
}

proc phobos_config {} {
    global env
    
    set t .phobos_config
    toplevel $t
    wm title $t "Phobos Configuration"
    wm resizable $t 0 0
    wm attributes $t -topmost 1
    
    frame $t.show
    frame $t.showColumn -bd 2 -relief groove
    label $t.showColumn.label -text "Columns displayed: "
    checkbutton $t.showColumn.unitLength -text "unit length" -variable env(repeat.unitLength) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.unit -text "unit" -variable env(repeat.unit) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.start -text "start" -variable env(repeat.start) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.end -text "end" -variable env(repeat.end) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.length -text "length" -variable env(repeat.length) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.score -text "score" -variable env(repeat.score) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.perfection -text "perfection" -variable env(repeat.perfection) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.mismatches -text "mismatches" -variable env(repeat.mismatches) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.insertions -text "insertions" -variable env(repeat.insertions) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.deletions -text "deletions" -variable env(repeat.deletions) -offvalue "-" -onvalue "+"
    checkbutton $t.showColumn.numOfNs -text "num. of Ns" -variable env(repeat.numOfNs) -offvalue "-" -onvalue "+"
    
    frame $t.buts -bd 2 -relief groove
    button $t.buts.ok -text "Set" -command "phobos_changeConfig repeat; destroy $t"
    button $t.buts.cancel -text "Cancel" -command "destroy $t"
    
    pack $t.showColumn.unitLength $t.showColumn.unit $t.showColumn.start $t.showColumn.end \
            $t.showColumn.length $t.showColumn.score $t.showColumn.perfection  $t.showColumn.mismatches \
            $t.showColumn.insertions $t.showColumn.deletions $t.showColumn.numOfNs -side top -anchor w
    pack $t.buts.ok $t.buts.cancel -side left -fill both
    pack $t.showColumn $t.buts -side top -fill both
}

proc phobos_changeConfig {mode} {
    global env
    global phobos_searchmode
    global phobos_indelScore
    global phobos_mismatchScore
    global phobos_minScore
    global phobos_minLength
    global phobos_maxUnitLen
    global phobos_minUnitLen
    global phobos_recursion
    global phobos_dontRemoveMostlyOverlapping
    global phobos_minPerfection
    global phobos_NPerfectionMode
    global phobos_NsAsMissense
    global phobos_succN
    
    if {$mode eq "repeat"} {
        if {$env(repeat.unitLength) eq "+"} {
            .result.notebook2.nb.frepeat.1.table.l columnconfigure 1 -hide no
        } else {
            .result.notebook2.nb.frepeat.1.table.l columnconfigure 1 -hide yes
        }
        if {$env(repeat.unit) eq "+"} {
            .result.notebook2.nb.frepeat.1.table.l columnconfigure 2 -hide no
        } else {
            .result.notebook2.nb.frepeat.1.table.l columnconfigure 2 -hide yes
        }
        if {$env(repeat.start) eq "+"} {
            .result.notebook2.nb.frepeat.1.table.l columnconfigure 3 -hide no
        } else {
            .result.notebook2.nb.frepeat.1.table.l columnconfigure 3 -hide yes
        }
        if {$env(repeat.end) eq "+"} {
            .result.notebook2.nb.frepeat.1.table.l columnconfigure 4 -hide no
        } else {
            .result.notebook2.nb.frepeat.1.table.l columnconfigure 4 -hide yes
        }
        if {$env(repeat.length) eq "+"} {
            .result.notebook2.nb.frepeat.1.table.l columnconfigure 5 -hide no
        } else {
            .result.notebook2.nb.frepeat.1.table.l columnconfigure 5 -hide yes
        }
        if {$env(repeat.score) eq "+"} {
            .result.notebook2.nb.frepeat.1.table.l columnconfigure 6 -hide no
        } else {
            .result.notebook2.nb.frepeat.1.table.l columnconfigure 6 -hide yes
        }
        if {$env(repeat.perfection) eq "+"} {
            .result.notebook2.nb.frepeat.1.table.l columnconfigure 7 -hide no
        } else {
            .result.notebook2.nb.frepeat.1.table.l columnconfigure 7 -hide yes
        }
        if {$env(repeat.mismatches) eq "+"} {
            .result.notebook2.nb.frepeat.1.table.l columnconfigure 8 -hide no
        } else {
            .result.notebook2.nb.frepeat.1.table.l columnconfigure 8 -hide yes
        }
        if {$env(repeat.insertions) eq "+"} {
            .result.notebook2.nb.frepeat.1.table.l columnconfigure 9 -hide no
        } else {
            .result.notebook2.nb.frepeat.1.table.l columnconfigure 9 -hide yes
        }
        if {$env(repeat.deletions) eq "+"} {
            .result.notebook2.nb.frepeat.1.table.l columnconfigure 10 -hide no
        } else {
            .result.notebook2.nb.frepeat.1.table.l columnconfigure 10 -hide yes
        }
        if {$env(repeat.numOfNs) eq "+"} {
            .result.notebook2.nb.frepeat.1.table.l columnconfigure 11 -hide no
        } else {
            .result.notebook2.nb.frepeat.1.table.l columnconfigure 11 -hide yes
        }
    } elseif {$mode eq "phobosparams"} {
        set phobos_searchmode [.phobos.params.searchmode.cb get]
        set phobos_indelScore [.phobos.params.indelScore.ent get]
        set phobos_mismatchScore [.phobos.params.mismatchScore.ent get]
        set phobos_minScore [.phobos.params.minScore.ent get]
        set phobos_minLength [.phobos.params.minLength.ent get]
        set phobos_maxUnitLen [.phobos.params.maxUnitLen.ent get]
        set phobos_minUnitLen [.phobos.params.minUnitLen.ent get]
        set phobos_recursion [.phobos.params.recursion.ent get]
        set phobos_minPerfection [.phobos.params.minPerfection.ent get]
        set phobos_NPerfectionMode [.phobos.params.nPerfectionMode.cb get]
        set phobos_succN [.phobos.params.succN.ent get]
    }
    if {[catch {set ft [open [pwd]/conf/phobos_tace.conf w]} ]} {
        puts "error"
    } else {
        puts $ft "Phobos Parameters"
        puts $ft "{$phobos_searchmode}\
                {$phobos_indelScore}\
                {$phobos_mismatchScore}\
                {$phobos_minScore}\
                {$phobos_minLength}\
                {$phobos_maxUnitLen}\
                {$phobos_minUnitLen}\
                {$phobos_recursion}\
                {$phobos_dontRemoveMostlyOverlapping}\
                {$phobos_minPerfection}\
                {$phobos_NPerfectionMode}\
                {$phobos_NsAsMissense}\
                {$phobos_succN}"
        puts $ft "Repeats"
        puts $ft "$env(repeat.unitLength) \
                $env(repeat.unit) \
                $env(repeat.start) \
                $env(repeat.end) \
                $env(repeat.length) \
                $env(repeat.score) \
                $env(repeat.perfection) \
                $env(repeat.mismatches) \
                $env(repeat.insertions) \
                $env(repeat.deletions) \
                $env(repeat.numOfNs)"
        close $ft
    }
}

proc rightmenu_phobos {mode feat id coord} {
    global env
    
    .rightmenu delete 0 end
    .rightmenu.hidemenuColumn delete 0 end
    .rightmenu.copymenu delete 0 end
    
    .rightmenu add cascade -label "Hide column..." -menu .rightmenu.hidemenuColumn
    .rightmenu.hidemenuColumn add command -label "$env(repeat.deletions) deletion" -command "table_col_sh .result.notebook2.nb.frepeat.1.table.l repeat.deletions 10"
    .rightmenu.hidemenuColumn add command -label "$env(repeat.end) end" -command "table_col_sh .result.notebook2.nb.frepeat.1.table.l repeat.end 4"
    .rightmenu.hidemenuColumn add command -label "$env(repeat.insertions) insertion" -command "table_col_sh .result.notebook2.nb.frepeat.1.table.l repeat.insertions 9"
    .rightmenu.hidemenuColumn add command -label "$env(repeat.length) length" -command "table_col_sh .result.notebook2.nb.frepeat.1.table.l repeat.length 5"
    .rightmenu.hidemenuColumn add command -label "$env(repeat.mismatches) mismatch" -command "table_col_sh .result.notebook2.nb.frepeat.1.table.l repeat.mismatches 8"
    .rightmenu.hidemenuColumn add command -label "$env(repeat.numOfNs) num of Ns" -command "table_col_sh .result.notebook2.nb.frepeat.1.table.l repeat.numOfNs 11"
    .rightmenu.hidemenuColumn add command -label "$env(repeat.perfection) perfection" -command "table_col_sh .result.notebook2.nb.frepeat.1.table.l repeat.perfection 7"
    .rightmenu.hidemenuColumn add command -label "$env(repeat.score) score" -command "table_col_sh .result.notebook2.nb.frepeat.1.table.l repeat.score 6"
    .rightmenu.hidemenuColumn add command -label "$env(repeat.start) start" -command "table_col_sh .result.notebook2.nb.frepeat.1.table.l repeat.start 3"
    .rightmenu.hidemenuColumn add command -label "$env(repeat.unit) unit" -command "table_col_sh .result.notebook2.nb.frepeat.1.table.l repeat.unit 2"
    .rightmenu.hidemenuColumn add command -label "$env(repeat.unitLength) unit length" -command "table_col_sh .result.notebook2.nb.frepeat.1.table.l repeat.unitLength 1"
    .rightmenu add command -label "Save config" -command "catch {phobos_changeConfig repeat}"
    .rightmenu add separator
    .rightmenu add cascade -label "Copy..." -menu .rightmenu.copymenu
    .rightmenu.copymenu add command -label "Cell" -command "catch {table_copy \"cell [lindex $coord 0] [lindex $coord 1]\" .result.notebook2.nb.frepeat.1.table.l}"
    .rightmenu.copymenu add command -label "Column" -command "catch {table_copy \"column [lindex $coord 0]\" .result.notebook2.nb.frepeat.1.table.l}"
    .rightmenu.copymenu add command -label "Row" -command "catch {table_copy \"row [lindex $coord 1]\" .result.notebook2.nb.frepeat.1.table.l}"
    .rightmenu.copymenu add command -label "Table" -command "catch {table_copy all .result.notebook2.nb.frepeat.1.table.l}"
    
    tk_popup .rightmenu [winfo pointerx .] [winfo pointery .]
}