proc sequence_viewer_init {} {
    global closeImg
    
    #Creating menu buttons
    .menubar.tab.menu add command -label "Sequence viewer" -command "catch {create_tab sv}"
    
    #Creating right-menu buttons
    
    # Sequence Viewer
    set notebook .result.notebook2.nb
    set frame [$notebook insert end sv -text "Sequence viewer" -raisecmd "catch {update_info_sv}"]
    frame $frame.0
    label $frame.0.label1 -font 12
    button $frame.0.exit -image $closeImg -highlightthickness 0 -takefocus 0 -command "close_tab sv"
    frame $frame.1
    text $frame.1.panel -background white -width 100 -height 1 -yscrollcommand "$frame.1.y set"
    scrollbar $frame.1.y -orient vertical -command "$frame.1.panel yview"
    
    pack $frame.0.label1 -side left -fill both -anchor w
    pack $frame.0.exit -side right -fill both -anchor e
    pack $frame.1.panel -fill both -side left -expand true; pack $frame.1.y -fill both -side left
    pack $frame.0 -side top -fill both; pack $frame.1 -side top -fill both -expand true
    
    .result.notebook2.nb.fsv.1.panel tag configure bold12 -font {-family courier -size 12 -weight bold}
    .result.notebook2.nb.fsv.1.panel tag configure bold11 -font {-family courier -size 11 -weight bold}
    .result.notebook2.nb.fsv.1.panel tag configure bold11r -font {-family courier -size 11 -weight bold} -foreground red2
    .result.notebook2.nb.fsv.1.panel tag configure bold_italics -font {-family courier -size 12 -weight bold -slant italic}
    .result.notebook2.nb.fsv.1.panel tag configure hel -font {-family helvetica -size 16 -weight bold}
    .result.notebook2.nb.fsv.1.panel tag configure helred -font {-family helvetica -size 16 -weight bold} -foreground red4
    .result.notebook2.nb.fsv.1.panel tag configure color1 -foreground red
    .result.notebook2.nb.fsv.1.panel tag configure smallBut -font {-family courier -size 6 -weight bold}
    .result.notebook2.nb.fsv.1.panel tag configure sunken -relief sunken -borderwidth 1
    
    .result.notebook2.nb.fsv.1.panel tag configure markedYellow -background yellow
    .result.notebook2.nb.fsv.1.panel tag configure markedGreen -background green
    .result.notebook2.nb.fsv.1.panel tag configure markedOrange -background orange
    .result.notebook2.nb.fsv.1.panel tag configure markedRed -background red
    .result.notebook2.nb.fsv.1.panel tag configure markedBlue -background blue
    .result.notebook2.nb.fsv.1.panel tag configure unmarked -background white
    .result.notebook2.nb.fsv.1.panel tag configure textGreen -foreground green
    
    bind .result.notebook2.nb.fsv.1.panel <Button-3> "
    rightmenu_sv sv sv - -
    "
}

proc sequence_viewer_remove {} {
    #Remove menu buttons
    .menubar.tab.menu delete "Sequence viewer"
    .result.notebook2.nb delete sv
}

proc update_info_sv {} {
    global env
    
    .result.notebook2.nb.fsv.1.panel delete 1.0 end
    if {$env(contig.dbType) eq "nucleotide"} {
        .result.notebook2.nb.fsv.1.panel insert end ">$env(contig.name) length=$env(contig.length) numreads=$env(contig.numreads)\n" bold11
        .result.notebook2.nb.fsv.1.panel insert end "$env(contig.sequence)\n\n"
        
        foreach prot $env(contig.proteinL) {
            .result.notebook2.nb.fsv.1.panel insert end ">[lindex $prot 5] length=[lindex $prot 2]\n" bold11
            .result.notebook2.nb.fsv.1.panel insert end "[lindex $prot 6]\n"
        }
    } elseif {$env(contig.dbType) eq "protein"} {
        foreach prot $env(contig.proteinL) {
            .result.notebook2.nb.fsv.1.panel insert end ">[lindex $prot 5] length=[lindex $prot 2]\n" bold11
            .result.notebook2.nb.fsv.1.panel insert end "[lindex $prot 6]\n\n"
        }
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, length, numreads, sequence FROM $env(dbName).sequences_nucleotide WHERE id_seq = '$env(contig.id_seq)'"}}]]
        foreach sRes $sql_res {
            .result.notebook1.nb.fsv.1.panel insert end ">[lindex $sRes 0] length=[lindex $sRes 1] numreads=[lindex $sRes 2]\n" bold11
            .result.notebook1.nb.fsv.1.panel insert end "[lindex $sRes 3]"
        }
        unset sql_res
    } elseif {$env(contig.dbType) eq "reads"} {
        .result.notebook2.nb.fsv.1.panel insert end ">$env(contig.name) length=$env(contig.length)\n" bold11
        .result.notebook2.nb.fsv.1.panel insert end "$env(contig.sequence)\n\n"
    }
    .result.notebook2.nb.fsv.0.label1 configure -text $env(contig.name)
}

proc rightmenu_sv {mode feat id coord} {
    global env
    
    .rightmenu delete 0 end
    .rightmenu.hidemenuColumn delete 0 end
    .rightmenu.copymenu delete 0 end
    
    .rightmenu add command -label "Search" -command "search_pattern_window search_pattern_mark .result.notebook2.nb.fsv.1.panel"
    
    if {[string length [.result.notebook2.nb.fsv.1.panel get -displaychars 1.0 end]] > 1} {
        tk_popup .rightmenu [winfo pointerx .] [winfo pointery .]
    }
}