proc blast_init {} {
    global env
    global closeImg
    global checkedImg
    global uncheckedImg
    global blast_inputFile
    global blast_program
    global blast_evalue
    global blast_hit
    global blast_hit2
    global blast_server
    global blast_url
    global blast_dbArr
    global blast_dbArrlocal
    global blast_alignmentCheck
    
    variable blast_inputFile
    variable blast_program
    variable blast_evalue
    variable blast_hit
    variable blast_url
    
    #BlastDBs
    set blast_dbArr(megablast) " "
    set blast_dbArr(blastn) " "
    set blast_dbArr(blastx) " "
    set blast_dbArr(tblastn) " "
    set blast_dbArr(tblastx) " "
    
    #Creating menu buttons
    .menubar.config.menu add command -label "Blast parameters" -command "blast_config"
    
    if {[catch {set ft [open [pwd]/conf/blast_tace.conf r]} ]} {
        #Blast
        set blast_program "blastx"
        set blast_evalue "1e-003"
        set blast_hit 10
        set blast_hit2 3
        set blast_server 0
        set blast_url "http://localhost/blast/blast.cgi"
        set blast_alignmentCheck 0
        set blast_onlyOverlapsCheck 0
    } else {
        #Blast
        gets $ft line
        gets $ft line
        set blast_program [lindex $line 0]
        set blast_evalue [lindex $line 1]
        set blast_hit [lindex $line 2]
        set blast_hit2 [lindex $line 3]
        set blast_server [lindex $line 4]
        set blast_url [lindex $line 5]
        set blast_alignmentCheck [lindex $line 6]
        set blast_onlyOverlapsCheck [lindex $line 7]
        #BlastDBs
        gets $ft line
        gets $ft line
        set blast_dbArr([lindex $line 0]) [lrange $line 1 end]
        gets $ft line
        set blast_dbArr([lindex $line 0]) [lrange $line 1 end]
        gets $ft line
        set blast_dbArr([lindex $line 0]) [lrange $line 1 end]
        gets $ft line
        set blast_dbArr([lindex $line 0]) [lrange $line 1 end]
        gets $ft line
        set blast_dbArr([lindex $line 0]) [lrange $line 1 end] 
    }
    
    # Blast
    set notebook .result.notebook1.nb
    set frame [$notebook insert end blast -text "Blast"]
    frame $frame.0 -bd 2 -relief groove
    radiobutton $frame.0.search -text "Search" -variable blastview_rb -value "Search" -command {pack forget .result.notebook1.nb.fblast.1; pack .result.notebook1.nb.fblast.2 -side top -fill both -expand true}
    radiobutton $frame.0.results -text "Results" -variable blastview_rb -value "Results" -command {pack forget .result.notebook1.nb.fblast.2; pack .result.notebook1.nb.fblast.1 -side top -fill both -expand true}
    $frame.0.search select
    checkbutton $frame.0.alignment -text "show alignment" -variable blast_alignmentCheck \
            -command {if {$blast_alignmentCheck} {pack .result.notebook1.nb.fblast.1.alignment -side bottom -fill both} else {pack forget .result.notebook1.nb.fblast.1.alignment}}
    frame $frame.1
    frame $frame.1.tab
    frame $frame.1.tab.table
    scrollbar $frame.1.tab.y -orient vertical -command "$frame.1.tab.table.l yview"
    scrollbar $frame.1.tab.table.x -orient horizontal -command "$frame.1.tab.table.l xview"
    set nb1_tl_blast $frame.1.tab.table.l
    tablelist::tablelist $nb1_tl_blast \
            -width 24 -height 1 -showseparators 1 -stripebackground lightblue\
            -columns {0 "" 0 "query" 0 "hit" 0 "perfection" 0 "length" 0 "eValue" 0 "score" 0 "qStart" 0 "qEnd" 0 "hStart" 0 "hEnd" 0 "nr" 0 "dbName"} \
            -labelcommand "$nb1_tl_blast finishediting; tablelist::sortByColumn" \
            -exportselection 0 \
            -selectmode single \
            -stretch {1 2} \
            -editendcommand editEndCmd \
            -yscrollcommand "$frame.1.tab.y set" \
            -xscrollcommand "$frame.1.tab.table.x set" \
            -background white
    $nb1_tl_blast columnconfigure 0 \
            -editable yes \
            -editwindow checkbutton \
            -formatcommand emptystr \
            -labelimage [expr {1 ? $checkedImg : $uncheckedImg}] \
            -labelcommand "table_selection"
    $nb1_tl_blast columnconfigure 1 -sortmode dictionary
    $nb1_tl_blast columnconfigure 2 -sortmode dictionary
    $nb1_tl_blast columnconfigure 3 -sortmode dictionary
    $nb1_tl_blast columnconfigure 11 -hide yes
    $nb1_tl_blast columnconfigure 12 -hide yes
    for {set c 3} {$c <= 10} {incr c} {
        $nb1_tl_blast columnconfigure $c -align right -sortmode real
    }
    frame $frame.1.alignment
    text $frame.1.alignment.panel -height 3 -background white -width 110 -xscrollcommand "$frame.1.alignment.x set" -wrap none
    scrollbar $frame.1.alignment.x -orient horizontal -command "$frame.1.alignment.panel xview"
    frame $frame.2
    frame $frame.2.panel
    text $frame.2.panel.p -height 1 -background white -yscrollcommand "$frame.2.panel.y set"
    scrollbar $frame.2.panel.y -orient vertical -command "$frame.2.panel.p yview"
    frame $frame.2.params1
    frame $frame.2.params2
    ComboBox $frame.2.params1.type -hottrack 1 -width 10 -background white -text "Database" -values {Database Project} -modifycmd "blast_modify type"
    ComboBox $frame.2.params1.dbs -hottrack 1 -width 30 -background white -text ""
    label $frame.2.params1.label2 -text "  Program: "
    ComboBox $frame.2.params1.program -hottrack 1 -listboxwidth 130 -width 8 -background white -modifycmd "blast_modify program" -text "$blast_program" -values {"blastn       'NvsNdb'" "blastp       'PvsPdb'" "blastx        'NvsPdb'" "tblastn        'PvsNdb'" "tblastx       'NvsNdb'"}
    label $frame.2.params1.label3 -text "  Min. eValue: "
    entry $frame.2.params1.evalue -width 6 -background white -textvariable blast_evalue
    label $frame.2.params1.label4 -text "  Max. hits: "
    entry $frame.2.params1.hit -width 3 -background white -textvariable blast_hit
    label $frame.2.params2.label5 -text "Input File: "
    entry $frame.2.params2.input -width 30 -background white -textvariable blast_inputFile
    button $frame.2.params2.browse -text "Browse" -command "blast_inputFile"
    button $frame.2.params2.blast -text "Blast" -command "blast"
    checkbutton $frame.2.params2.onlyOverlap -text "overlaps only" -variable blast_onlyOverlapsCheck
    button $frame.2.params2.clear -text "Clear" -command ".result.notebook1.nb.fblast.2.panel.p delete 1.0 end"
    
    pack $frame.0.search $frame.0.results -side left -fill both -anchor w
    pack $frame.0.alignment -side right -fill both -anchor e
    pack $frame.2.panel.p -side left -fill both -expand true; pack $frame.2.panel.y -side left -fill both
    pack $frame.2.params1.type $frame.2.params1.dbs $frame.2.params1.label2 $frame.2.params1.program $frame.2.params1.label3 \
            $frame.2.params1.evalue $frame.2.params1.label4 $frame.2.params1.hit -side left -fill both -anchor w
    pack $frame.2.params2.label5 $frame.2.params2.input $frame.2.params2.browse $frame.2.params2.blast $frame.2.params2.onlyOverlap -side left -fill both -anchor w
    pack $frame.2.params2.clear -side right -fill both -anchor e
    pack $frame.2.params1 $frame.2.params2 -side top -fill both; pack $frame.2.panel -side top -fill both -expand true
    pack $frame.1.alignment.panel $frame.1.alignment.x -side top -fill both
    pack $frame.1.tab.table.l -side top -fill both -expand true; pack $frame.1.tab.table.x -side top -fill both
    pack $frame.1.tab.y -side left -fill both; pack $frame.1.tab.table -side left -fill both -expand true
    pack $frame.1.tab -side top -fill both -expand true
    if {$blast_alignmentCheck} {
        pack $frame.1.alignment -side bottom -fill both
    }
    pack $frame.0 -side top -fill both
    pack $frame.2 -side top -fill both -expand true
    
    #Blast
    set tl .result.notebook1.nb.fblast.1.tab.table.l
    bind [$tl bodypath] <Button-3> "
    set y \[$tl nearest \[expr {%y + \[winfo y %W\]}\]\]
    catch \{set coord \"\[expr {%x + \[winfo x %W\]}\] \[expr {%y + \[winfo y %W\]}\]\"\}
    set db \[lindex \[$tl get \$y\] 12\]
    set id \[lindex \[$tl get \$y\] 2\]
    rightmenu_blast blast \$db \$id \$coord
    "
}

proc blast_remove {} {
    #Removing menu buttons
    .menubar.config.menu delete "Blast parameters"
}

proc blast {} {
    global blast_alignmentCheck
    global blast_onlyOverlapsCheck
    global blastArr
    global blast_url
    global blast_server
    global blast_hit2
    
    set blastArr(blastHitL) " "
    set blastArr(queryL) " "
    
    .result.notebook1.nb.fblast.2.params2.blast configure -state disabled
    set type [.result.notebook1.nb.fblast.2.params1.type get]
    set db [.result.notebook1.nb.fblast.2.params1.dbs get]
    set program [lindex [.result.notebook1.nb.fblast.2.params1.program get] 0]
    set evalue [.result.notebook1.nb.fblast.2.params1.evalue get]
    set hit [.result.notebook1.nb.fblast.2.params1.hit get]
    if {[string index $evalue 0] eq "e"} {
        set evalue "1$evalue"
    }
    
    set nucL ""
    if {$type eq "Project"} {
        set prj [regsub -all {[()]} [lindex $db end] ""]
        set i 0
        
        set dbL ""
        while {[.result.notebook1.nb.f$prj.1.table.l get $i] ne ""} {
            if {[lindex [.result.notebook1.nb.f$prj.1.table.l get $i] 0] eq 1} {
                lappend nucL [lindex [.result.notebook1.nb.f$prj.1.table.l get $i] 2]
                lappend dbL [lindex [.result.notebook1.nb.f$prj.1.table.l get $i] 24]
            }
            incr i
        }
        set dbL [lsort -unique $dbL]
        if {[llength $dbL] eq 1} {
            set db $dbL
        } else {
            errorPopUp "Error" "$db contains entries from more than 1 database."
            set db ""
        }
        unset dbL
    }
    
    set input ""
    set strH ""
    set input [string trimright [.result.notebook1.nb.fblast.2.panel.p get -displaychars 1.0 end]]
    if {$input ne ""} {
        set input "{[regsub -all {\n} $input "\} \{"]}"
        set strS ""
        foreach line $input {
            if {[string index $line 0] eq ">"} {
                if {$strS ne ""} {
                    lappend blastArr(queryL) "{$strH} {$strS}"
                    set strH [string range $line 1 end]
                    set strS ""
                } else {
                    set strH [string range $line 1 end]
                }
            } else {
                append strS "$line"
            }
        }
        if {$strH eq ""} {
            set strH Query
        }
        lappend blastArr(queryL) "{$strH} {$strS}"
        unset strH; unset strS
    } else {
        set blastArr(queryL) ""
        if {[catch {set ft [open [.result.notebook1.nb.fblast.2.params2.input get] r]} ]} {
        } else {
            set strH ""
            set strS ""
            while {[gets $ft line] != -1} {
                if {[string index $line 0] eq ">"} {
                    if {$strS ne ""} {
                        lappend blastArr(queryL) "{$strH} {$strS}"
                        set strH [string range $line 1 end]
                        set strS ""
                    } else {
                        set strH [string range $line 1 end]
                    }
                } else {
                    append strS "$line"
                }
            }
            lappend blastArr(queryL) "{$strH} {$strS}"
            close $ft
        }
    }
    if {$blast_server} {
        foreach q $blastArr(queryL) {
            set str ""
            set startQuery -1
            set startHit -1
            set matchLine 0
            set score ""
            set seqMatch ""
            set seqQuery ""
            set seqHit ""
            
            set query [lindex $q 0]
            set seq [lindex $q 1]
            set que [::http::formatQuery >$query\n$seq]
            if {[catch {set token [::http::geturl $blast_url -query "PROGRAM=$program&DATALIB=$db&EXPECT=$evalue&ALIGNMENTS=$hit&SEQUENCE=$que"]}]} {
                errorPopUp "Error" "Could not open socket.\nPlease check URL."
            } else {
                set str [::http::data $token]
                http::cleanup $token
                set str [regsub -all {["]} $str ""]
                set str [regsub -all {>} $str " "]
                
                set str "{[regsub -all {\n} $str "\} \{"]}"
                if {[lindex [lindex $str 0] 3] eq "Error"} {
                    errorPopUp "Error - Blast" "Selected database is not existing or\nnot compatible to selected blast program."
                } else {
                    set count 1
                    set count2 1
                    set id ""
                    set mLStart ""
                    foreach line $str {
                        if {[lindex $line 0] eq "<a"} {
                            if {$score ne ""} {
                                if {$id ne $query} {
                                    set id $query
                                    set count 1
                                }
                                if {$count <= $hit} {
                                    if {$blast_onlyOverlapsCheck} {
                                        if {$count2 <= $blast_hit2 && ($startQuery <= 15 || $endQuery >= [expr [string length $seq] - 15]) && [lindex $query 0] ne "$hitID"} {
                                            lappend blastArr(blastHitL) "{$query} {$hitID} $perfection $length $expect $score $startQuery $endQuery $startHit $endHit [string toupper $seqQuery] [string toupper $seqHit] {$seqMatch} $db"
                                            incr count
                                        }
                                    } else {
                                        if {$count2 <= $blast_hit2 && [lindex $query 0] ne "$hitID"} {
                                            lappend blastArr(blastHitL) "{$query} {$hitID} $perfection $length $expect $score $startQuery $endQuery $startHit $endHit [string toupper $seqQuery] [string toupper $seqHit] {$seqMatch} $db"
                                            incr count
                                        }
                                    }
                                    set hitID [regsub -all {</a} [lindex $line 5] ""]
                                    set score ""
                                    set seqQuery ""
                                    set seqMatch ""
                                    set seqHit ""
                                    set startQuery -1
                                    set startHit -1
                                    set mLStart ""
                                    set count2 1
                                }
                            } else {
                                set hitID [regsub -all {</a} [lindex $line 5] ""]
                            }
                        } elseif {[lindex $line 0] eq "Score"} {
                            if {$score ne ""} {
                                if {$count <= $hit} {
                                    if {$blast_onlyOverlapsCheck} {
                                        if {$count2 <= $blast_hit2 && ($startQuery <= 15 || $endQuery >= [expr [string length $seq] - 15]) && [lindex $query 0] ne "$hitID"} {
                                            lappend blastArr(blastHitL) "{$query} {$hitID} $perfection $length $expect $score $startQuery $endQuery $startHit $endHit [string toupper $seqQuery] [string toupper $seqHit] {$seqMatch} $db"
                                            set score ""
                                            set seqQuery ""
                                            set seqMatch ""
                                            set seqHit ""
                                            set startQuery -1
                                            set startHit -1
                                            set mLStart ""
                                            incr count2
                                        }
                                    } else {
                                        if {$count2 <= $blast_hit2 && [lindex $query 0] ne "$hitID"} {
                                            lappend blastArr(blastHitL) "{$query} {$hitID} $perfection $length $expect $score $startQuery $endQuery $startHit $endHit [string toupper $seqQuery] [string toupper $seqHit] {$seqMatch} $db"
                                            set score ""
                                            set seqQuery ""
                                            set seqMatch ""
                                            set seqHit ""
                                            set startQuery -1
                                            set startHit -1
                                            set mLStart ""
                                            incr count2
                                        }
                                    }
                                }
                            }
                            set score [lindex $line 2]
                            set expect [lindex $line 7]
                            if {[string index $expect end] eq ","} {
                                set expect [string range $expect 0 [expr [string length $expect] - 2]]
                            }
                            if {[string index $expect 0] eq "e"} {
                                set expect "1$expect"
                            }
                        } elseif {[lindex $line 0] eq "Identities"} {
                            set length [lindex [regsub -all {/} [lindex $line 2] " "] 1]
                            set perfection [regsub -all {\(} [regsub -all {\)} [regsub -all {,} [lindex $line 3] ""] ""] ""]
                        } elseif {[lindex $line 0] eq "Strand"} {
                            set strandQuery [lindex $line 2]
                            set strandHit [lindex $line 3]
                        } elseif {[lindex $line 0] eq "Query:"} {
                            append seqQuery [lindex $line 2]
                            if {$startQuery eq -1} {
                                set startQuery [lindex $line 1]
                                set endQuery [lindex $line end]
                            } else {
                                set endQuery [lindex $line end]
                            }
                            set matchLine 1
                        } elseif {$matchLine} {
                            if {$mLStart eq ""} {
                                for {set i 0} {$i < [string length $line]} {incr i} {
                                    if {[string index $line $i] ne " "} {
                                        set mLStart $i
                                        break
                                    }
                                }
                            }
                            append seqMatch [string range $line $mLStart end]
                            set matchLine 0
                        } elseif {[lindex $line 0] eq "Sbjct:"} {
                            append seqHit [lindex $line 2]
                            if {$startHit eq -1} {
                                set startHit [lindex $line 1]
                                set endHit [lindex $line end]
                            } else {
                                set endHit [lindex $line end]
                            }
                        }
                    }
                    if {$score ne "" && $count <= $hit} {
                        if {$blast_onlyOverlapsCheck} {
                            if {($startQuery <= 15 || $endQuery >= [expr [string length $seq] - 15]) && [lindex $query 0] ne "$hitID"} {
                                lappend blastArr(blastHitL) "{$query} {$hitID} $perfection $length $expect $score $startQuery $endQuery $startHit $endHit [string toupper $seqQuery] [string toupper $seqHit] {$seqMatch} $db"
                                unset seqQuery
                                unset seqMatch
                                unset seqHit
                            }
                        } elseif {[lindex $query 0] ne "$hitID"} {
                            lappend blastArr(blastHitL) "{$query} {$hitID} $perfection $length $expect $score $startQuery $endQuery $startHit $endHit [string toupper $seqQuery] [string toupper $seqHit] {$seqMatch} $db"
                            unset seqQuery
                            unset seqMatch
                            unset seqHit
                        }
                    }
                }
            }
        }
    } else {
        set startQuery -1
        set startHit -1
        set matchLine 0
        set score ""
        set seqMatch ""
        set seqQuery ""
        set seqHit ""
        set out ""
        foreach q $blastArr(queryL) {
            append out ">[lindex $q 0]\n[lindex $q 1]\n"
        }
        if {[catch {set ft [open [pwd]/blast_dbs/blast_tmp.fasta w]} ]} {
            errorPopUp "Error - Blast" "Could not create blast-input file."
        } else {
            puts $ft $out
            close $ft
            unset out
            set str ""
            catch {set str [eval exec "$program -evalue $evalue -db [pwd]/blast_dbs/$db -query [pwd]/blast_dbs/blast_tmp.fasta -culling_limit $hit"]} str
            catch {file delete [pwd]/blast_dbs/blast_tmp.fasta}
            set str [regsub -all {["]} $str ""]
            set str "{[regsub -all {\n} $str "\} \{"]}"
            if {[lindex [lindex $str 0] 2] eq "error:"} {
                errorPopUp "Error - Blast" "Selected database is not existing or\nnot compatible to selected blast program."
            } else {
                set count 1
                set count2 1
                set id ""
                set mLStart ""
                foreach line $str {
                    if {[lindex $line 0] eq "Query="} {
                        set query [lrange $line 1 end]
                        foreach que $blastArr(queryL) {
                            set seq ""
                            if {[lindex $que 0] eq $query} {
                                set seq [lindex $que 1]
                                break
                            }
                        }
                    } elseif {[string index $line 0] eq ">"} {
                        if {$score ne ""} {
                            if {$id ne $query} {
                                set id $query
                                set count 1
                            }
                            if {$count <= $hit} {
                                if {$blast_onlyOverlapsCheck} {
                                    if {$count2 <= $blast_hit2 && ($startQuery <= 15 || $endQuery >= [expr [string length $seq] - 15]) && [lindex $query 0] ne "$hitID"} {
                                        lappend blastArr(blastHitL) "{$query} {$hitID} $perfection $length $expect $score $startQuery $endQuery $startHit $endHit [string toupper $seqQuery] [string toupper $seqHit] {$seqMatch} $db $seq_length"
                                        incr count
                                    }
                                } else {
                                    if {$count2 <= $blast_hit2 && [lindex $query 0] ne "$hitID"} {
                                        lappend blastArr(blastHitL) "{$query} {$hitID} $perfection $length $expect $score $startQuery $endQuery $startHit $endHit [string toupper $seqQuery] [string toupper $seqHit] {$seqMatch} $db $seq_length"
                                        incr count
                                    }
                                }
                                set hitID [string range [lindex $line 0] 1 end]
                                if {[string range $hitID 0 3] eq "lcl|"} {
                                    set hitID [string range $hitID 4 end]
                                }
                                set score ""
                                set seqQuery ""
                                set seqMatch ""
                                set seqHit ""
                                set startQuery -1
                                set startHit -1
                                set mLStart ""
                                set count2 1
                            }
                        } else {
                            set hitID [string range [lindex $line 0] 1 end]
                            if {[string range $hitID 0 3] eq "lcl|"} {
                                set hitID [string range $hitID 4 end]
                            }
                        }
                    } elseif {[string range $line 0 6] eq "Length="} {
                        set seq_length [string range $line 7 end]
                    } elseif {[lindex $line 0] eq "Score"} {
                        if {$score ne ""} {
                            if {$count <= $hit} {
                                if {$blast_onlyOverlapsCheck} {
                                    if {$count2 <= $blast_hit2 && ($startQuery <= 15 || $endQuery >= [expr [string length $seq] - 15]) && [lindex $query 0] ne "$hitID"} {
                                        lappend blastArr(blastHitL) "{$query} {$hitID} $perfection $length $expect $score $startQuery $endQuery $startHit $endHit [string toupper $seqQuery] [string toupper $seqHit] {$seqMatch} $db $seq_length"
                                        set score ""
                                        set seqQuery ""
                                        set seqMatch ""
                                        set seqHit ""
                                        set startQuery -1
                                        set startHit -1
                                        set mLStart ""
                                        incr count2
                                    }
                                } else {
                                    if {$count2 <= $blast_hit2 && [lindex $query 0] ne "$hitID"} {
                                        lappend blastArr(blastHitL) "{$query} {$hitID} $perfection $length $expect $score $startQuery $endQuery $startHit $endHit [string toupper $seqQuery] [string toupper $seqHit] {$seqMatch} $db $seq_length"
                                        set score ""
                                        set seqQuery ""
                                        set seqMatch ""
                                        set seqHit ""
                                        set startQuery -1
                                        set startHit -1
                                        set mLStart ""
                                        incr count2
                                    }
                                }
                            }
                        }
                        set score [lindex $line 2]
                        set expect [lindex $line 7]
                        if {[string index $expect end] eq ","} {
                            set expect [string range $expect 0 [expr [string length $expect] - 2]]
                        }
                        if {[string index $expect 0] eq "e"} {
                            set expect "1$expect"
                        }
                    } elseif {[lindex $line 0] eq "Identities"} {
                        set length [lindex [regsub -all {/} [lindex $line 2] " "] 1]
                        set perfection [regsub -all {\(} [regsub -all {\)} [regsub -all {,} [lindex $line 3] ""] ""] ""]
                    } elseif {[lindex $line 0] eq "Strand"} {
                        set strandQuery [lindex $line 2]
                        set strandHit [lindex $line 3]
                    } elseif {[lindex $line 0] eq "Query"} {
                        append seqQuery [lindex $line 2]
                        if {$startQuery eq -1} {
                            set startQuery [lindex $line 1]
                            set endQuery [lindex $line end]
                        } else {
                            set endQuery [lindex $line end]
                        }
                        set matchLine 1
                    } elseif {$matchLine} {
                        if {$mLStart eq ""} {
                            for {set i 0} {$i < [string length $line]} {incr i} {
                                if {[string index $line $i] ne " "} {
                                    set mLStart $i
                                    break
                                }
                            }
                        }
                        append seqMatch [string range $line $mLStart end]
                        set matchLine 0
                    } elseif {[lindex $line 0] eq "Sbjct"} {
                        append seqHit [lindex $line 2]
                        if {$startHit eq -1} {
                            set startHit [lindex $line 1]
                            set endHit [lindex $line end]
                        } else {
                            set endHit [lindex $line end]
                        }
                    }
                }
                if {$score ne "" && $count <= $hit} {
                    if {$blast_onlyOverlapsCheck} {
                        if {($startQuery <= 15 || $endQuery >= [expr [string length $seq] - 15]) && [lindex $query 0] ne "$hitID"} {
                            lappend blastArr(blastHitL) "{$query} {$hitID} $perfection $length $expect $score $startQuery $endQuery $startHit $endHit [string toupper $seqQuery] [string toupper $seqHit] {$seqMatch} $db $seq_length"
                            unset seqQuery
                            unset seqMatch
                            unset seqHit
                        }
                    } elseif {[lindex $query 0] ne "$hitID"} {
                        lappend blastArr(blastHitL) "{$query} {$hitID} $perfection $length $expect $score $startQuery $endQuery $startHit $endHit [string toupper $seqQuery] [string toupper $seqHit] {$seqMatch} $db $seq_length"
                        unset seqQuery
                        unset seqMatch
                        unset seqHit
                    }
                }
            }
        }
    }
    if {$nucL ne ""} {
        set hitL ""
        set tmpL $blastArr(blastHitL)
        
        foreach hit $tmpL {
            set i [lsearch $nucL [lindex $hit 1]]
            if {$i ne -1} {
                lappend hitL $hit
            }
        }
        set blastArr(blastHitL) $hitL
        unset tmpL; unset hitL
    }
    fillTable .result.notebook1.nb.fblast.1.tab.table.l 0 0
    .result.notebook1.nb.fblast.2.params2.blast configure -state normal
}

proc blast_add_seq {db id_seq} {
    global env
    
    if {$db eq "sequence_edit"} {
        .result.notebook1.nb.fblast.2.panel.p insert end "$id_seq"
    } elseif {$db eq "keggM2"} {
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, length, numreads, sequence FROM $env(dbName).sequences_nucleotide WHERE id_seq = '$id_seq'"}}]]
        foreach ent $sql_res {
            .result.notebook1.nb.fblast.2.panel.p insert end ">[lindex $ent 0] length=[lindex $ent 1] numreads=[lindex $ent 2]\n" bold11
            .result.notebook1.nb.fblast.2.panel.p insert end "[lindex $ent 3]\n\n"
        }
        unset sql_res
    } else {
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT name, length, numreads, sequence FROM [string tolower $db].sequences_nucleotide WHERE id_seq = '$id_seq'"}}]]
        foreach ent $sql_res {
            .result.notebook1.nb.fblast.2.panel.p insert end ">[lindex $ent 0] length=[lindex $ent 1] numreads=[lindex $ent 2]\n" bold11
            .result.notebook1.nb.fblast.2.panel.p insert end "[lindex $ent 3]\n\n"
        }
        unset sql_res
    }
}

proc blast_modify {mode} {
    global env
    global blast_program
    global blast_dbArrlocal
    
    set current_db [.result.notebook1.nb.fblast.2.params1.dbs get]
    if {$current_db eq ""} {
        set current_db "empty######"
    }
    
    if {$mode eq "type"} {
        if {[.result.notebook1.nb.fblast.2.params1.type get] eq "Database"} {
            set i [lsearch -regexp $blast_dbArrlocal([lindex [.result.notebook1.nb.fblast.2.params1.program get] 0]) $current_db]
            if {$i ne -1} {
                .result.notebook1.nb.fblast.2.params1.dbs configure -values $blast_dbArrlocal([lindex [.result.notebook1.nb.fblast.2.params1.program get] 0]) -text "[lindex $blast_dbArrlocal([lindex [.result.notebook1.nb.fblast.2.params1.program get] 0]) $i]"
            } else {
                set i [lsearch -regexp $blast_dbArrlocal([lindex [.result.notebook1.nb.fblast.2.params1.program get] 0]) $env(dbName)]
                if {$i ne -1} {
                    .result.notebook1.nb.fblast.2.params1.dbs configure -values $blast_dbArrlocal([lindex [.result.notebook1.nb.fblast.2.params1.program get] 0]) -text "$env(dbName)"
                } else {
                    .result.notebook1.nb.fblast.2.params1.dbs configure -values $blast_dbArrlocal([lindex [.result.notebook1.nb.fblast.2.params1.program get] 0]) -text "[lindex $blast_dbArrlocal([lindex [.result.notebook1.nb.fblast.2.params1.program get] 0]) 0]"
                }
            }
        } elseif {[.result.notebook1.nb.fblast.2.params1.type get] eq "Project"} {
            set values ""
            foreach page [.result.notebook1.nb pages] {
                if {[string range $page 0 2] eq "prj"} {
                    lappend values "[.result.notebook1.nb itemcget $page -text] ($page)"
                }
            }
            .result.notebook1.nb.fblast.2.params1.dbs configure -values $values -text "[lindex $values 0]"
            unset values
        }
    } elseif {$mode eq "program"} {
        set blast_program [.result.notebook1.nb.fblast.2.params1.program get]
        if {[.result.notebook1.nb.fblast.2.params1.type get] eq "Database"} {
            set i [lsearch -regexp $blast_dbArrlocal([lindex [.result.notebook1.nb.fblast.2.params1.program get] 0]) $current_db]
            if {$i ne -1} {
                .result.notebook1.nb.fblast.2.params1.dbs configure -values $blast_dbArrlocal([lindex [.result.notebook1.nb.fblast.2.params1.program get] 0]) -text "[lindex $blast_dbArrlocal([lindex [.result.notebook1.nb.fblast.2.params1.program get] 0]) $i]"
            } else {
                set i [lsearch -regexp $blast_dbArrlocal([lindex [.result.notebook1.nb.fblast.2.params1.program get] 0]) $env(dbName)]
                if {$i ne -1} {
                    .result.notebook1.nb.fblast.2.params1.dbs configure -values $blast_dbArrlocal([lindex [.result.notebook1.nb.fblast.2.params1.program get] 0]) -text "$env(dbName)"
                } else {
                    .result.notebook1.nb.fblast.2.params1.dbs configure -values $blast_dbArrlocal([lindex [.result.notebook1.nb.fblast.2.params1.program get] 0]) -text "[lindex $blast_dbArrlocal([lindex [.result.notebook1.nb.fblast.2.params1.program get] 0]) 0]"
                }
            }
        }
    }
}

proc blast_inputFile {} {
    global blast_inputFile
    set blast_inputFile [browse open {{{Fasta Files} {.fa .fas .fna .fasta .txt} } {{All Files} * }} -]
}

proc blast_dbL {} {
    global blast_server
    global env
    global blast_dbArrlocal
    global blast_program
    
    set blast_dbArrlocal(blastp) ""
    set blast_dbArrlocal(blastx) ""
    set blast_dbArrlocal(blastn) ""
    set blast_dbArrlocal(tblastn) ""
    set blast_dbArrlocal(tblastx) ""
    
    if {$blast_server} {
        foreach db $env(dbL) {
            lappend blast_dbArrlocal(blastn) [lindex $db 0]
            lappend blast_dbArrlocal(tblastn) [lindex $db 0]
            lappend blast_dbArrlocal(tblastx) [lindex $db 0]
            lappend blast_dbArrlocal(blastn) "[lindex $db 0]_reads"
            lappend blast_dbArrlocal(tblastn) "[lindex $db 0]_reads"
            lappend blast_dbArrlocal(tblastx) "[lindex $db 0]_reads"
        }
        foreach prog {blastn blastp blastx tblastn tblastx} {
            set blast_dbArrlocal($prog) [lsort -unique $blast_dbArrlocal($prog)]
        }
        .result.notebook1.nb.fblast.2.params1.dbs configure -values $blast_dbArrlocal([lindex $blast_program 0])
    } else {
        catch {
            foreach db "[glob -path [pwd]/blast_dbs/ -tails *.n*]" {
                lappend blast_dbArrlocal(blastn) [lindex [split $db .] 0]
                lappend blast_dbArrlocal(tblastn) [lindex [split $db .] 0]
                lappend blast_dbArrlocal(tblastx) [lindex [split $db .] 0]
            }
        }
        catch {
            foreach db "[glob -path [pwd]/blast_dbs/ -tails *.\p*]" {
                lappend blast_dbArrlocal(blastp) [lindex [split $db .] 0]
                lappend blast_dbArrlocal(blastx) [lindex [split $db .] 0]
            }
        }
        foreach prog {blastn blastp blastx tblastn tblastx} {
            set blast_dbArrlocal($prog) [lsort -unique $blast_dbArrlocal($prog)]
        }
        .result.notebook1.nb.fblast.2.params1.dbs configure -values $blast_dbArrlocal([lindex $blast_program 0])
    }
    if {$env(dbName) eq " "} {
        .result.notebook1.nb.fblast.2.params1.dbs configure -text [lindex $blast_dbArrlocal([lindex $blast_program 0]) 0]
    } else {
        set in [lsearch $blast_dbArrlocal([lindex $blast_program 0]) "$env(dbName)"]
        if {$in ne -1} {
            .result.notebook1.nb.fblast.2.params1.dbs configure -text $env(dbName)
        } else  {
            .result.notebook1.nb.fblast.2.params1.dbs configure -text [lindex $blast_dbArrlocal([lindex $blast_program 0]) 0]
        }
    }
}

proc blast_config {} {
    global blast_program
    global blast_evalue
    global blast_hit
    global blast_hit2
    global blast_alignmentCheck
    global blast_onlyOverlapsCheck
    global blast_url
    global blast_server
    
    set t .blast_config
    toplevel $t
    wm title $t "Blast Configuration"
    wm resizable $t 0 0
    wm attributes $t -topmost 1
    
    frame $t.program
    label $t.program.label -text "Program:"
    ComboBox $t.program.ent -width 10 -hottrack 1 -listboxwidth 130 -background white -textvariable blast_program -values {"blastn       'NvsNdb'" "blastx        'NvsPdb'" "megablast 'NvsNdb'" "tblastn        'PvsNdb'" "tblastx       'NvsNdb'"}
    frame $t.evalue
    label $t.evalue.label -text "min. eValue:"
    entry $t.evalue.ent -width 10 -background white -textvariable blast_evalue
    frame $t.hit
    label $t.hit.label -text "Number of different results:"
    entry $t.hit.ent -width 10 -background white -textvariable blast_hit
    frame $t.hit2
    label $t.hit2.label -text "Number of Hits per result:"
    entry $t.hit2.ent -width 10 -background white -textvariable blast_hit2
    frame $t.url
    radiobutton $t.url.r -text "URL: " -variable blast_server -value "1" -command blast_dbL
    entry $t.url.ent -width 35 -background white -textvariable blast_url
    radiobutton $t.r -text "Local blast" -variable blast_server -value "0" -command blast_dbL
    checkbutton $t.alignment -text "show Blast alignment" -variable blast_alignmentCheck
    checkbutton $t.overlaps -text "overlaps only" -variable blast_onlyOverlapsCheck
    
    frame $t.buts -bd 2 -relief groove
    button $t.buts.ok -text "Set" -command "blast_configChange; destroy $t"
    button $t.buts.cancel -text "Cancel" -command "destroy $t"
    
    pack $t.program.label -side left -fill both; pack $t.program.ent -side right -fill both
    pack $t.evalue.label -side left -fill both; pack $t.evalue.ent -side right -fill both
    pack $t.hit.label -side left -fill both; pack $t.hit.ent -side right -fill both
    pack $t.hit2.label -side left -fill both; pack $t.hit2.ent -side right -fill both
    pack $t.url.r -side left -fill both -anchor w; pack $t.url.ent -side right -fill both
    pack $t.buts.ok $t.buts.cancel -side left -fill both
    pack $t.program $t.evalue $t.hit $t.hit2 $t.r $t.url $t.alignment $t.overlaps $t.buts -side top -anchor w
    
    wm geometry $t +[expr [winfo rootx .]+[winfo width .]/2]+[expr [winfo rooty .]+[winfo height .]/2]
    raise $t
}

proc blast_configChange {} {
    global env
    
    global blast_program
    global blast_evalue
    global blast_hit
    global blast_hit2
    global blast_server
    global blast_url
    global blast_dbArr
    global blast_alignmentCheck
    global blast_onlyOverlapsCheck
    
    global browserPath
    
    set out "[pwd]/conf/blast_tace.conf"
    
    set blast_program [.blast_config.program.ent get]
    set blast_evalue [.blast_config.evalue.ent get]
    set blast_hit [.blast_config.hit.ent get]
    set blast_hit2 [.blast_config.hit2.ent get]
    set blast_url [.blast_config.url.ent get]
    .result.notebook1.nb.fblast.2.params1.program configure -text "$blast_program"
    .result.notebook1.nb.fblast.2.params1.evalue configure -text "$blast_evalue"
    .result.notebook1.nb.fblast.2.params1.hit configure -text "$blast_hit"
    if {$blast_alignmentCheck} {
        pack .result.notebook1.nb.fblast.1.alignment -side bottom -fill both
    } else {
        pack forget .result.notebook1.nb.fblast.1.alignment
    }
    
    if {[catch {set ft [open $out w]} ]} {
    } else {
        puts $ft "Blast"
        puts $ft "[lindex $blast_program 0] $blast_evalue $blast_hit $blast_hit2 $blast_server {$blast_url} $blast_alignmentCheck $blast_onlyOverlapsCheck"
        puts $ft "BlastDBs"
        puts $ft "megablast\t$blast_dbArr(megablast)"
        puts $ft "blastn\t$blast_dbArr(blastn)"
        puts $ft "blastx\t$blast_dbArr(blastx)"
        puts $ft "tblastn\t$blast_dbArr(tblastn)"
        puts $ft "tblastx\t$blast_dbArr(tblastx)"
        close $ft
    }
}

proc update_info_blast_table {name nr} {
    global env
    global blastArr
    global blast_alignmentCheck
    
    if {$blast_alignmentCheck} {
        if {[string length [lindex [lindex $blastArr(blastHitL) $nr] 12]] > [string length [lindex [lindex $blastArr(blastHitL) $nr] 10]]} {
            set len [string length [lindex [lindex $blastArr(blastHitL) $nr] 12]]
        } else {
            set len [string length [lindex [lindex $blastArr(blastHitL) $nr] 10]]
        }
        .result.notebook1.nb.fblast.1.alignment.panel delete 1.0 end
        .result.notebook1.nb.fblast.1.alignment.panel configure -width $len
        .result.notebook1.nb.fblast.1.alignment.panel insert end "[lindex [lindex $blastArr(blastHitL) $nr] 10]\n[lindex [lindex $blastArr(blastHitL) $nr] 12]\n[lindex [lindex $blastArr(blastHitL) $nr] 11]"
    }
    update_info_get_name $name name
}

proc rightmenu_blast {mode feat id coord} {
    global env
    
    .rightmenu delete 0 end
    .rightmenu.hidemenuColumn delete 0 end
    .rightmenu.copymenu delete 0 end
    
    global env
    catch {
        set sql_res [eval [subst {thread::send $::threadPHP {::php_getSQLresults "SELECT id_seq FROM $feat.sequences_nucleotide WHERE name = '$id'"}}]]
        foreach sRes $sql_res {
            set id [lindex $sRes 0]
        }
        unset sql_res
        if {[lsearch $env(loaded_modules) "sequence_edit_tace"] ne -1} {
            .rightmenu add command -label "Edit sequence" -command "catch {sequence_edit_window $feat $id}"
        }
        .rightmenu add command -label "New sequence" -command "catch {database_nucleotide_new_window $feat $id}"
        .rightmenu add separator
    }
    .rightmenu add cascade -label "Copy..." -menu .rightmenu.copymenu
    .rightmenu.copymenu add command -label "Cell" -command "catch {table_copy \"cell [lindex $coord 0] [lindex $coord 1]\" .result.notebook1.nb.fblast.1.tab.table.l}"
    .rightmenu.copymenu add command -label "Column" -command "catch {table_copy \"column [lindex $coord 0]\" .result.notebook1.nb.fblast.1.tab.table.l}"
    .rightmenu.copymenu add command -label "Row" -command "catch {table_copy \"row [lindex $coord 1]\" .result.notebook1.nb.fblast.1.tab.table.l}"
    .rightmenu.copymenu add command -label "Table" -command "catch {table_copy all .result.notebook1.nb.fblast.1.tab.table.l}"
    
    tk_popup .rightmenu [winfo pointerx .] [winfo pointery .]
}